      PROGRAM PEAK
C
C     *********************
C     *                   *
C     *      P E A K      *
C     *                   *
C     *********************
C
C
C     CURVE FITTING PROGRAM PEAK
C     BY
C     A. HEPP
C     INSTITUT FUER KRISTALLOGRAPHIE UND PETROGRAPHIE
C     ETH
C     CH-8092 ZURICH
C     SWITZERLAND
C
C
C     THIS PROGRAM CALCULATES A STANDARD LINE PROFILE
C     FROM THE DATA OF A MEASURED LINE
C
C     IT IS A PROTOTYPE WHICH MAY STILL BE OPTIMIZED IN
C     MANY RESPECTS
C
      LOGICAL FLAG
      CHARACTER*1 XXXX
      DIMENSION TEMP(201),YNW(201),CARR(201),CNTS(201),TTH(201),Y(201)
     $,TTINP(201),DYS(201),DYA(201),RI(102),FSI(102),FAI(102)
     $,ABCD(4,201),DFSI(102),DFAI(102),YS(201),YA(201),TIT(21)
      EQUIVALENCE (Y(1),YNW(1))
      DIMENSION XXXX(74)
C     DIMENSION LIMIT
      IDIM=201
C
      NTOUT=6
      IPROF = 14
C
C     WRITE HEADING
      WRITE(6,100)
  100 FORMAT(1x,'CALCULATION OF STANDARD PEAK PROFILE FUNCTION'/
     $ 45(1H*)///)
      READ(5,105)  TIT
  105 FORMAT(A4,A2,18A4,A2)
      WRITE(6,110)  (TIT(I),I=3,21)
  110 FORMAT(1x,'TITLE OF JOB: ',18A4,A2)
C     DEFINE SOME CONSTANTS
      IREX=0
      IASS=0
      ICYCA=0
      ASMIN=0.05
      AEPS=1.0E-4
C     NUMBER OF STEPS USED FOR THE TABULATION OF THE STANDARD PEAK
      NSTEPS=50
      FSTEPS=FLOAT(NSTEPS)
      NST1=NSTEPS+1
      NST2=NSTEPS+2
C     ADDITIONAL STEP SUBDIVISION IN SUBROUTINE LSFIT
      ISCF=3
C     READ PRESCRIBED DATA FROM CARD
C     TTL,TTU: LOWER AND UPPER LIMIT OF THE RANGE TO BE READ
C     IHWFR: MAXIMUM RANGE OF CALCULATED STANDARD PEAK IN
C     NUMBER OF HALFWIDTHS (DEFAULT= VALUE CALCULATED BY PROGRAM)
C     NCC NUMBER OF ITERATION CYCLES IN LSFIT (DEFAULT=10)
      READ(5,1000) TTL,TTU,IHWFR,NCC
 1000 FORMAT(2F10.2,2I3)
      IF(NCC.EQ.0) GO TO 1006
      ICYCA=1
      WRITE (NTOUT,1004)NCC
 1004 FORMAT(1x,'NUMBER OF CYCLES SET TO',I4,' SKIP CONVERGENCE TEST')
      GO TO 1008
 1006 NCC=10
 1008 CMAX=0.0
      NEF=0
C     READ FILE WITH DATA OF PEAK
C     THETC, COUNT: TWO-THETA, OBSERVED COUNTS
      READ(IPROF,8000) XXXX
 8000 FORMAT(80A1)
      WRITE(6,1015) (XXXX(I),I=1,74)
 1015 FORMAT(1x,'PROFILE READ WITH LABEL: ',74A1)
      WRITE(12,1016) (TIT(I),I=3,21)
 1016 FORMAT('TITLE ',18A4,A2)
      READ(IPROF,8001) THETC
    5 READ(IPROF,8001,END=15) THETC,COUNT
 8001 FORMAT(2F10.4)
CTAM  IF(EOF(IPROF)) 15,10
   10 IF(THETC.LT.TTL) GO TO 5
      IF(THETC.GE.TTU) GO TO 15
      NEF=NEF+1
      IF(NEF.LE.IDIM) GO TO 11
C     DIMENSION LIMIT IS EXCEEDED
      NEF=NEF-1
      IREX=1
      GO TO 15
   11 TTH(NEF)=THETC
      CARR(NEF)=COUNT
      CC=CARR(NEF)
      IF(CC.LT.CMAX) GO TO 5
C     FIND APPROXIMATELY THE MAXIMUM OF THE OBSERVED DATA
      CMAX=CC
      NMAX=NEF
      GO TO 5
   15 WRITE (NTOUT,1002)TTL,TTU
 1002 FORMAT(1x,'GIVEN RANGE FROM',F7.2,' TO',F7.2,' DEGREES')
      WRITE (NTOUT,999)NEF
  999 FORMAT(1x,'START WITH',I5,' OBSERVATIONS')
      WRITE (NTOUT,2998)IHWFR
 2998 FORMAT(1x,'GIVEN HALFWIDTH FACTOR =',I3)
      T12=TTH(3)-TTH(2)
      TMAX=TTH(NMAX)
C     DETERMINE BACKGROUND AT BEGINNING AND END OF RANGE.  USE AVERAGE
C     VALUE OF FIRST FIVE AND LAST FIVE MEASUREMENTS.
      JUNK = NEF - 5
      QTQ1 = 0.
      QTQ2 = 0.
      DO 611 I=1,5
      QTQ1 = QTQ1 + CARR(I)
      QTQ2 = QTQ2 + CARR(JUNK+I)
  611 CONTINUE
      QTQ1 = QTQ1/5.0
      QTQ2 = QTQ2/5.0
      QTQ3 = (QTQ2-QTQ1)/(TTH(NEF)-TTH(1))
      WRITE (6,613) TTH(3),QTQ1,TTH(NEF-3),QTQ2
  613 FORMAT(1x,'LINEAR BACKGROUND CORRECTION:  ',F8.2,F10.2,' COUNTS ',
     $2F10.2,' COUNTS')
C     SUBTRACT BACKGROUND
      DO 615 I=1,NEF
      CARR(I) = CARR(I) - (QTQ1 + (TTH(I)-TTH(1))*QTQ3)
C     SAVE 2 THETA AND CORRECTED COUNTS
      TTINP(I) = TTH(I)
  615 CNTS(I) = CARR(I)
      NPNTS = NEF
      CMAX = CARR(NMAX)
C     DETERMINE A MORE PRECISE POSITION OF THE MAXIMUM
      CALL FINDPK(CARR,NMAX,XMAX,CMAX,1,NEF)
C     NEARLY ALL CALCULATIONS ARE CARRIED OUT ON THE X-SCALE
C     WITH X GOING FROM 1 TO 201
      XSHFT=XMAX-FLOAT(NMAX)
      TSHFT=T12*XSHFT
      TMAX=TMAX+TSHFT
      ICMAX=CMAX
      WRITE (NTOUT,900)TMAX,ICMAX
  900 FORMAT(1x,'PEAK POSITION AND HEIGHT ABOUT',F7.2,
     $' DEGREES AND',I7,' COUNTS')
      YHW=0.5*CMAX
C     FIND THE POINTS AT NOH1 AND NOH2 WITH APPROXIMATELY
C     HALF HEIGHT
      DO 16 NO=1,NMAX
      NON=NMAX+1-NO
      NOH1=NON
      IF(CARR(NON).LT.YHW) GO TO 17
   16 CONTINUE
   17 DO 18 NO=NMAX,NEF
      NOH2=NO
      IF(CARR(NO).LT.YHW) GO TO 19
   18 CONTINUE
   19 NHD1=NMAX-NOH1
      NHD2=NOH2-NMAX
C     NHD IS THE SMALLER ONE OF THE DISTANCES FROM THE POSITION
C     OF THE MAXIMUM TO NOH1 AND NOH2
      NHD=MIN0(NHD1,NHD2)
      XSTEP=1.0
      IF(NHD.GE.4) GO TO 21
      XSTEP=0.25*FLOAT(NHD)
      NHD1=FLOAT(NHD1)/XSTEP
      NHD2=FLOAT(NHD2)/XSTEP
C     PERFORM AN INTERPOLATION TO GET NEW POINTS SHIFTED
C     IN A WAY THAT TMAX IS STORED AT THE POSITION 101
C     IF THERE ARE LT 4 POINTS PER HALFWIDTH REDUCE STEPLENGTH
C     SPLINE SUBROUTINE INTPOL PREPARES THE ARRAY ABCD OF
C     COEFFICIENTS USED BY FINTPL
   21 CALL INTPOL(1,NEF,CARR,TEMP,ABCD)
      TSTEP=T12*XSTEP
      XT=XMAX-100.0*XSTEP
      TT=TMAX-100.0*TSTEP
      TU=TMAX+100.0*TSTEP
C     IREX=1: A PART OF THE DATA RANGE READ WILL BE CUT OFF
      IF(TT.GT.TTL.OR.TU.LT.TTU) IREX=1
      FNEF=FLOAT(NEF)
      DO 20 NO=1,201
      CARR(NO)=0.0
      TTH(NO)=TT
      TT=TT+TSTEP
      IF(XT.LT.1.0.OR.XT.GT.FNEF) GO TO 20
C     EVALUATE THE SPLINES AT THE POINTS XT AND STORE THE
C     FUNCTION VALUES IN CARR
      CALL FINTPL(1,NEF,ABCD,XT,CARR(NO))
   20 XT=XT+XSTEP
      T12=TSTEP
CTAM  NTH1=NTH2=0
      NTH1=0
      NTH2=0
C     FIND THE POSITIONS NTH1 TO THE LEFT AND NTH2 TO THE RIGHT
C     OF THE PEAK WITH THE LAST AND THE FIRST ONE OF THE DATA
C     VALUES EQUAL TO ZERO
      DO 35 NO=1,201
      NON=202-NO
      CA=CARR(NO)
      CAN=CARR(NON)
      IF(NTH1.NE.0) GO TO 40
      IF(CA.NE.0.0) NTH1=NO-1
   40 IF(NTH2.NE.0) GO TO 45
      IF(CAN.NE.0.0) NTH2=NON+1
   45 NTN=NTH1*NTH2
      IF(NTN.NE.0) GO TO 50
   35 CONTINUE
   50 NTHD1=101-NTH1
      NTHD2=NTH2-101
C     FIND NTD, THE GREATER OF THE DISTANCES FROM THE POSITION
C     OF THE MAXIMUM TO NTH1 AND NTH2, AND NHD, THE GREATER ONE OF
C     NHD1 AND NHD2
      NTD=MAX0(NTHD1,NTHD2)
      NHD=MAX0(NHD1,NHD2)
C     HD5 IS USED LATER FOR THE DAMPING OF THE ASYMMETRIC PART
      HD5=5.0*FLOAT(NHD)
C     MINIMUM RANGE IHWF IN HALFWIDTHS NEEDED FOR THE CURVE
C     BEING CALCULATED IN LSFIT
      IHWF=NTD/NHD+1
C     TAKE THE MAXIMUM OF IHWF AND IHWFR READ IN
      IHWF=MAX0(IHWF,IHWFR)
      IF(IHWF*NHD.LE.100) GO TO 46
C     PARTS OF THE GIVEN DATA RANGE WILL BE CUT OFF
      IREX=1
      IHWF=100.0/FLOAT(NHD)
C     NL: FIRST VALUE NE 0 AT THE LOWER, NU: LAST VALUE NE 0
C     AT THE UPPER HALF OF THE PEAK
   46 NL=101-IHWF*NHD
      NU=101+IHWF*NHD
      WRITE (NTOUT,3333)IHWF,TTH(NL),TTH(NU)
 3333 FORMAT(1x,'RANGE CHANGED TO ABOUT',I3,' HALFWIDTHS',
     $' FROM',F7.2,' TO',F7.2,' DEGREES')
      IF(IREX.EQ.1) WRITE (NTOUT,998)
  998 FORMAT(1x,'ATTENTION: PARTS OF THE DESIRED RANGE MAY',
     $' NOW BE CUT OFF')
      NEF=NU-NL+1
      WRITE (NTOUT,997)NEF,T12
  997 FORMAT(1x,'CHANGED NUMBER OF OBSERVATIONS AND 2-THETA',
     $' STEP:',I5,' AND',F7.4,' DEGREES')
C     SUBROUTINE LSFIT CALCULATES A CURVE Y FITTING THE DATA
C     STORED IN CARR
      CALL LSFIT(CARR,Y,NL,NU,ISCF,NCC,ICYCA)
C     PLOT OF OBSERVED AND CALCULATED CURVE (NOT USED AT PRESENT)
C     CALL PLOTP(TTH,CARR,Y,17)
C     EXACT MAXIMUM TX,YSM OF CALCULATED CURVE
      CALL FINDPK(Y,101,TX,YSM,NL,NU)
      DELT=TX-101.0
C     POSITION OF THE MAXIMUM IN THE 2-THETA SCALE
      TTHX=TTH(101)+T12*DELT
      WRITE (NTOUT,1003)
 1003 FORMAT(' ')
      WRITE (NTOUT,4442)TTHX
 4442 FORMAT(1x,'MAXIMUM FOUND AT',F8.3,' DEGREES')
C     BEGINNING OF THE CALCULATIONS TO DECOMPOSE CURVE IN A
C     SYMMETRIC AND A ASYMMETRIC PART
C     SUBROUTINE INTPOL PREPARES ARRAY ABCD
      CALL INTPOL(1,201,Y,TEMP,ABCD)
C     DEFINE SOME SMALL NUMBERS
      EPS=1.0E-3
      EPSH=EPS
      EPS=EPS*YSM
      EPS1=0.1*EPS
      EPSA=10.0*EPS
      NLE=0
C     DECOMPOSITION OF CURVE
      DO 350 NO=1,201
      TP=FLOAT(NO)+DELT
      TEMP(NO)=TTH(NO)+T12*DELT
      TN=2.0*TX-TP
C     EVALUATION OF Y AT TP AND TN SYMMETRICALLY TO TX
C     GIVES VALUES YP AND YN
      CALL FINTPL(1,201,ABCD,TP,YP)
      IF(YP.LT.EPS1) YP=EPS1
      CALL FINTPL(1,201,ABCD,TN,YN)
      IF(YN.LT.EPS1) YN=EPS1
      YPNH=0.5*(YP+YN)
CTAM  YS(NO)=YA(NO)=0.0
      YS(NO)=0.0
      YA(NO)=0.0
      IF(YPNH.LE.0.0) GO TO 349
C     SYMMETRICAL PART OF Y
      YS(NO)=YPNH
C     ASYMMETRICAL PART OF Y
C     EPSA GIVES A DAMPING OF YA FOR SMALL VALUES OF Y
      YA(NO)=(YPNH-YP)/(YPNH+EPSA)
      DNO=FLOAT(NO-101)
      Q=DNO/HD5
      Q=Q**8
      Q=1.0/(1.0+Q)
C     A SECOND KIND OF DAMPING IS APPLIED TO YA
      YA(NO)=YA(NO)*Q
C     FIND POINT WHERE YS IS DEFINITELY SMALLER THAN EPSH
c  349 IF(YS(NO).LT.EPS.AND.NO.GT.101) NLE=NLE+1

  349 IF(YS(NO).LT.EPSH.AND.NO.GT.101) NLE=NLE+1
c      IF(YS(NO).GE.EPS.AND.NLE.LE.3) NLEPS=NO+1
      IF(YS(NO).GE.EPSH.AND.NLE.LE.3) NLEPS=NO+1
  350 CONTINUE
C     PLOT OF SYMMETRIC AND ASYMMETRIC PART
      CALL PLOTP(TEMP,YS,YA,22,TIT,1,201)
C     EXACT HALFWIDTH HW OF YS (HW=0.5*WIDTH AT HALF HEIGHT)
      CALL HWIDTH(YS,101,HW,NL,NU)
C     DETERMINATION OF LENGTH IN HALFWIDTHS OF CURVE RANGE
C     WITH VALUES GREATER THAN EPSH
C     THERE IS NO NEED TO STORE VALUES FROM A LARGER RANGE
      FHWF1=(FLOAT(NLEPS)-101.0)/HW
      IHWF=FHWF1+1.0
C     EVENTUAL CURVE RANGE IN HALFWIDTHS
      FHWF=FLOAT(IHWF)
      THW=101.0+HW
C     HALFWIDTH HWT AND TOTAL HALFWIDTH HWT2 IN DEGREES 2-THETA
      HWT=T12*HW
      HWT2=2.0*HWT
C     PREPARATION OF COEFFICIENTS ABCD FOR INTERPOLATION OF YS
C     TO GET FSI AT NST1 POINTS FROM MAXIMUM TO UPPER END OF
C     DESIRED HALFWIDTH RANGE
      CALL INTPOL(1,201,YS,DYS,ABCD)
      RSTEP=FHWF/FSTEPS
      WRITE (NTOUT,4439)HWT2
 4439 FORMAT(1x,'TOTAL HALFWIDTH =',F9.6,' DEGREES')
      TSTEP=HW*RSTEP
      RR=0.0
      TT=101.0
C     INTERPOLATE YS TO GET FSI. FSI HAS STILL TO BE NORMALIZED
      DO 353 NO=1,NST1
      CALL FINTPL(1,201,ABCD,TT,FSI(NO))
      RI(NO)=RR
      TT=TT+TSTEP
  353 RR=RR+RSTEP
C     PREPARATIONS FOR THE INTERPOLATION OF YA TO GET FAI
      CALL INTPOL(1,201,YA,DYA,ABCD)
C     VALUE OF YA AT UPPER HALFWIDTH POINT
      CALL FINTPL(1,201,ABCD,THW,YAHW)
      AAS=ABS(YAHW)
C     TEST IF ASYMMETRY IS VERY SMALL
      IF(AAS.LT.ASMIN) IASS=1
CTAM  I1=I2=THW
      I1=THW
      I2=THW
      I1=I1+1
  340 IF(AAS.GE.AEPS) GO TO 356
C     IF THE ASYMMETRY AT THW IS TOO SMALL ONE HAS TO FIND A
C     BETTER POINT OF THE CURVE OF YA OR PERHAPS TO TAKE AEPS
C     ISTEAD
      I1=I1-1
      I2=I2+1
      IF(I1.EQ.201) YAHW=AEPS
      IF(I1.EQ.201) GO TO 356
      YAHW=0.5*(YA(I1)+YA(I2))
      AAS=ABS(YAHW)
      GO TO 340
  356 SY=1.0
C     SIGN OF YA AT THW
      IF(YAHW.LT.0.0) SY=-1.0
      WRITE (NTOUT,4438)YAHW
 4438 FORMAT(1x,'ASYMMETRY AT UPPER HALFWIDTH POINT =',F9.6)
      IF(IASS.EQ.1) WRITE (NTOUT,4443)
 4443 FORMAT(1x,'ATTENTION: THIS IS A RATHER SMALL VALUE')
      YAHW=SY*YAHW
C     FACTOR TO NORMALIZE FAI
      RAHW=1.0/YAHW
      TT=101.0
C     INTERPOLATE YA TO GET FAI. FAI HAS STILL TO BE NORMALIZED
      DO 354 NO=1,NST1
      CALL FINTPL(1,201,ABCD,TT,FAI(NO))
  354 TT=TT+TSTEP
C     TO CALCULATE DERIVATIVES MOST EASILY THE ARRAYS FSI AND FAI
C     ARE SUPPLEMENTED BY VALUES OF THE LOWER HALF OF THE CURVE
C     AND TEMPORARILY STORED IN YS AND YA
      NNN=2*NSTEPS+1
      DO 352 NO=1,NNN
      IF(NO.GE.NST1) GO TO 351
      YS(NO)=FSI(NST2-NO)
      YA(NO)=-FAI(NST2-NO)
  351 IF(NO.LT.NST1) GO TO 352
      YS(NO)=FSI(NO-NSTEPS)
      YA(NO)=FAI(NO-NSTEPS)
  352 CONTINUE
C     CALCULATIONS OF DERIVATIVES DYS AND DYA
      CALL INTPOL(1,NNN,YS,DYS,ABCD)
      CALL INTPOL(1,NNN,YA,DYA,ABCD)
CTAM  FAI(1)=DYS(NST1)=0.0
      FAI(1)=0.0
      DYS(NST1)=0.0
C     EVALUATE INTEGRAL OF FSI FROM 1 TO NST1 AND STORE IT
C     IN FINT
      CALL INTEG(FSI,1,NST1,FINT)
C     NORMALISATION CONSTANTS FOR FSI, FAI, DFSI AND DFAI
      DERF=FSTEPS/FHWF
      FINT=2.0*FINT/DERF
      CONST=1.0/FINT
      SFAC=CONST*DERF
      AFAC=RAHW*DERF
      WRITE (NTOUT,1003)
      WRITE (NTOUT,4437)
 4437 FORMAT(1x,'FUNCTION VALUES AND DERIVATIVES OF STANDARD PEAK:')
      WRITE (NTOUT,1003)
      WRITE (NTOUT,4445)
 4445 FORMAT(4X,2HNO,8X,2HRI,13X,3HFSI,12X,3HFAI,12X,4HDFSI,11X,4HDFAI)
      WRITE (NTOUT,1003)
C     EVENTUAL VALUES OF SYMMETRIC AND ASYMMETRIC PARTS FSI AND FAI
C     AND THEIR DERIVATIVES DFSI AND DFAI AS FUNCTIONS OF RI
C     THE UNIT OF RI IS ONE HALFWIDTH (RI=0.0: MAXIMUM, RI=1.0:
C     UPPER POINT OF HALF HEIGHT)
      DO 355 NO=1,NST1
      FSI(NO)=CONST*FSI(NO)
      FAI(NO)=RAHW*FAI(NO)
      DFSI(NO)=SFAC*DYS(NO+NSTEPS)
      DFAI(NO)=AFAC*DYA(NO+NSTEPS)
  355 WRITE (NTOUT,3503)NO,RI(NO),FSI(NO),FAI(NO),DFSI(NO),DFAI(NO)
 3503 FORMAT(1x,I5,6E15.5)
      WRITE (NTOUT,1001)
 1001 FORMAT(1x,'OBSERVED AND CALCULATED PEAK')
C     AS A CHECK THE TWO PARTS OF THE CURVE ARE PUT TOGETHER AGAIN
C     AND THE RESULT LISTED WITH THE OBSERVED DATA
      WRITE (NTOUT,1003)
      WRITE (NTOUT,3501)
 3501 FORMAT(1x,6X,'TWO-THETA',11X,'YOBS',10X,'YCALC')
      WRITE (NTOUT,1003)
      EPS = 0.001
      EPSY = EPS * CMAX
      RL = FHWF
      RR = 0.
      TTU = TTU + T12/2.
      DO 365 NO=1,NPNTS
      YNW(NO)=0.0
      R=(TTINP(NO)-TTHX)/HWT
      AR=ABS(R/RSTEP)
      IR1=AR
      AIR=FLOAT(IR1)
      IR1=IR1+1
      IF(IR1.GE.NST1) GO TO 360
      IR2=IR1+1
      RD=AR-AIR
      F1=FSI(IR1)
      FS=F1+RD*(FSI(IR2)-F1)
      F1=FAI(IR1)
      FA=F1+RD*(FAI(IR2)-F1)
      FSY=FINT*FS
      FAY=YAHW*FA
      IF(R.LE.0.0) FSFA=FSY*(1.0+FAY)
      IF(R.GT.0.0) FSFA=FSY*(1.0-FAY)
      YNW(NO)=FSFA
      IF(YNW(NO).GT.EPSY)  GO TO 360
      IF(R)  357,360,358
  357 RL = -R
      GO TO 360
  358 IF(RR)  359,359,360
  359 RR = R
  360 WRITE (NTOUT,3502)TTINP(NO),CNTS(NO),YNW(NO)
 3502 FORMAT(1x,3F15.2)
  365 CONTINUE
C     PLOT OF OBSERVED DATA AND CURVE OBTAINED BY PUTTING TOGETHER
C     SYMMETRIC AND ASYMMETRIC PART
      CALL PLOTP(TTINP,CNTS,YNW,16,TIT,1,NPNTS)
      R = AMAX1(RL,RR)
      WRITE(NTOUT,4441) EPS,R
 4441 FORMAT(//1x,'FUNCTION VALUES LESS THAN',F9.4,
     $' TIMES YMAX OUTSIDE',F6.2,' HALFWIDTHS')
      IR = R + 1.0
      R = IR
      WRITE(6,4440)  R
 4440 FORMAT(1x,'CHOSEN PEAK RANGE FACTOR =',F6.0)
C     WRITE DATA OF STANDARD PROFILE ON FILE 12
      WRITE(12,3600) R
 3600 FORMAT('PEAKF    1   51',F10.2)
      DO 370 NO=1,NST1
  370 WRITE(12,5000) RI(NO),FSI(NO),FAI(NO),DFSI(NO),DFAI(NO)
 5000 FORMAT(12X,5E12.4)
      END
      SUBROUTINE INTEG(A,NL,NU,FINT)
C     CALCULATES THE INTEGRAL OF A FUNCTION STORED IN A FROM
C     NL TO NU. THE RESULT IS STORED IN FINT
C     GAUSSIAN INTEGRATION IS USED WITH STEPS SUBDIVIDED
C     BY NS. AT INTERMEDIATE POINTS THE FUNCTION IS INTERPOLATED
C     BY SPLINES
      DIMENSION A(102),T(201),ABCD(4,201)
      CALL INTPOL(NL,NU,A,T,ABCD)
      NS=15
      ST=1.0/FLOAT(NS+1)
      NLL=NL+1
      SUM=0.5*A(NL)
      DO 5 I=NLL,NU
      XT=FLOAT(I-1)
      DO 10 KS=1,NS
      XT=XT+ST
      CALL FINTPL(NL,NU,ABCD,XT,FPL)
   10 SUM=SUM+FPL
    5 SUM=SUM+A(I)
      FINT=(SUM-0.5*A(NU))*ST
      RETURN
      END
      SUBROUTINE HWIDTH(Y,MX,HW,NL,NU)
C     DETERMINES THE DISTANCE HW FROM THE POSITION MX OF THE
C     MAXIMUM OF Y TO THE POSITION OF THE TWO POINTS HAVING
C     HALF HEIGHT (Y HAS TO BE SYMMETRIC WITH RESPECT TO MX)
      DIMENSION Y(601),ABCD(4,201),Y1(201)
      IST=1000
      DT=1.0/IST
      YHW=0.5*Y(MX)
      CALL INTPOL(NL,NU,Y,Y1,ABCD)
      DO 1 I=1,MX
      YB=Y(I)
      IB=I
      IF(YB.GT.YHW) GO TO 2
    1 CONTINUE
    2 IA=IB-1
      YB=Y(IA)
      TB=FLOAT(IA)
      DO 3 I=1,IST
      YA=YB
      TB=TB+DT
      CALL FINTPL(NL,NU,ABCD,TB,YB)
      IF(YB.GT.YHW) GO TO 4
    3 CONTINUE
    4 TA=TB-DT
      THW=TB
      DBA=YB-YA
      IF(DBA.EQ.0.0) GO TO 5
      THW=DT*(YHW-YA)/DBA+TA
    5 HW=FLOAT(MX)-THW
      RETURN
      END
      SUBROUTINE INTPOL(NL,NU,Y,Y1,ABCD)
C     SPLINE INTERPOLATION SUBROUTINE USING RATIONAL SPLINES.
C     ADAPTED SUBROUTINE RASPL1 (SPAETH, H.: SPLINE-ALGORITHMEN
C     ZUR KONSTRUKTION GLATTER KURVEN UND FLAECHEN.
C     R. OLDENBURG VERLAG MUENCHEN WIEN (1978), P.103)
C     Y,Y1,Y2: FUNCTION TO BE INTERPOLATED, FIRST AND SECOND
C     DERIVATIVES
C     ABCD: ARRAY OF COEFFICIENTS USED BY FINTPL
      DIMENSION Y(601),Y1(601),ABCD(4,601)
      P22=12.0
      PP1=13.0
      PPP=3458.0
      BK=1.0/143.0
      HP=133.0/143.0
CTAM  ABCD(3,NL)=ABCD(4,NL)=0.0
      ABCD(3,NL)=0.0
      ABCD(4,NL)=0.0
      NLP1=NL+1
      NU1=NU-1
      Y1(NL)=0.0
      Y1(NU)=0.0
      DO 2 K=NL,NU1
      KP1=K+1
      ABCD(1,K)=1.0
      ABCD(2,K)=BK
      R2=BK*(Y(KP1)-Y(K))
      IF(K.EQ.NL) GO TO 2
      KM1=K-1
      Z=1.0/(HP*(P22-ABCD(3,KM1))+HP*P22)
      ABCD(3,K)=Z*HP
      H=R2*PPP
      IF(K.EQ.NLP1) H=H-HP*Y1(NL)
      IF(K.EQ.NU1) H=H-HP*Y1(NU)
      IF(ABS(ABCD(4,KM1)).LE.0.1E-30) ABCD(4,KM1) = 0.0
      ABCD(4,K)=Z*(H-HP*ABCD(4,KM1))
    2 CONTINUE
      Y1(NU1)=ABCD(4,NU1)
      IF(NU1.LE.NLP1) GO TO 4
      N2=NU-NL-1
      DO 3 KK=2,N2
      K=NU-KK
      IF(ABS(Y1(K+1)).LE.0.1E-30) Y1(K+1) = 0.0
      Y1(K)=ABCD(4,K)-ABCD(3,K)*Y1(K+1)
    3 CONTINUE
    4 DO 5 K=NL,NU1
      KP1=K+1
      H=ABCD(2,K)*(Y(KP1)-Y(K))
      Z=ABCD(2,K)*ABCD(1,K)
      IF(ABS(Y1(KP1)).LE.0.1E-30) Y1(KP1) = 0.0
      ABCD(3,K)=PP1*H-Z*(Y1(KP1)+P22*Y1(K))
      ABCD(4,K)=-PP1*H+Z*(P22*Y1(KP1)+Y1(K))
      ABCD(1,K)=Y(K)-ABCD(3,K)
      ABCD(2,K)=Y(KP1)-ABCD(4,K)
    5 CONTINUE
      RETURN
      END
      SUBROUTINE FINTPL(NL,NU,ABCD,X,FPL)
C     EVALUATES INTERPOLATED VALUE FPL AT X BY MEANS OF THE
C     COEFFICIENTS ABCD SUPPLIED BY INTPOL
      DIMENSION ABCD(4,601)
      P=10.0
      IF(X.GT.FLOAT(NU)) X=FLOAT(NU)
      IF(X.LT.FLOAT(NL)) X=FLOAT(NL)
      NR=X
      IF(NR.LT.NL) NR=NL
      NU1=NU-1
      IF(NR.GT.NU1) NR=NU1
      T=X-FLOAT(NR)
      IF(NR.EQ.NL.AND.T.LT.0.0) T=0.0
      IF(NR.EQ.NU1.AND.T.GT.1.0) T=1.0
      U=1.0-T
      T3=T**3
      U3=U**3
      TR=1.0/(P*T+1.0)
      UR=1.0/(P*U+1.0)
      IF(ABS(ABCD(1,NR)).LE.1.E-30) ABCD(1,NR) = 0.0
      IF(ABS(ABCD(2,NR)).LE.1.E-30) ABCD(2,NR) = 0.0
      IF(ABS(ABCD(3,NR)).LE.1.E-24) ABCD(3,NR) = 0.0
      IF(ABS(ABCD(4,NR)).LE.1.E-24) ABCD(4,NR) = 0.0
      FPL=ABCD(1,NR)*U+ABCD(2,NR)*T+ABCD(3,NR)*U3*TR+ABCD(4,NR)*T3*UR
      RETURN
      END
      SUBROUTINE PLOTP(TT,A1,A2,NPLOT,TIT,N1,N2)
C     WRITES DATA OF CURVES A1(TT) AND A2(TT) ON PLOTFILE
      DIMENSION TT(201),A1(601),A2(601),TIT(21)
      INCR=1
      WRITE(NPLOT,1000) (TIT(I),I=3,21)
 1000 FORMAT('TITLE ',18A4,A2)
      WRITE(NPLOT,1005) TT(N1),TT(N2),INCR
 1005 FORMAT(2F10.2,I5)
      DO 5 NO=N1,N2
    5 WRITE(NPLOT,1010) TT(NO),A1(NO),A2(NO)
 1010 FORMAT(F10.4,2E14.6)
      RETURN
      END
      SUBROUTINE LSFIT(YR,Y,NL,NU,ISCF,NCC,ICYCA)
C     FITS A CURVE Y TO THE DATA OF THE MEASURED LINE PROFILE
C     STORED IN YR
      DIMENSION YR(1),Y(601)
     $,D(601),ABCD(4,601)
     $,YRR(601),YY(601),PTS(100,2),ISUM(100,8)
      NTOUT=6
      IPRI=0
      ICVT=0
      IPDIM=100
      RVAL=0.0
      EPS=1.0E-5
      EPSW=0.01
      FISCF=FLOAT(ISCF)
      ISP1=ISCF+1
      RISCF=1.0/FISCF
      ISEND=1+200*ISCF
      IEMS=ISEND-ISCF
      ICENT=1+100*ISCF
      FCENT=FLOAT(ICENT)
C     SPLINES SUBROUTINE INTPOL CALCULATES COEFFICIENTS ABCD
C     TO BE USED BY FINTPL TO GENERATE ARTIFICIAL OBSERVATIONS
C     ALL OBSERVATIONS ARE STORED THEN IN YRR
      CALL INTPOL(1,201,YR,D,ABCD)
      TI=1.0-RISCF
      DO 323 I=1,ISEND
      TI=TI+RISCF
  323 CALL FINTPL(1,201,ABCD,TI,YRR(I))
C     SAVE LOWER AND UPPER END OF RANGE CONTAINING OBSERVATIONS
C     (POSITIONS BEFORE SUBDIVISION BY ISCF)
      NLH=NL
      NUH=NU
C     ENDPOINTS AS GIVEN IN THE RANGE CONTAINING ISCF*(STEPS BEFORE) STE
      NL=1+ISCF*(NL-1)
      NU=1+ISCF*(NU-1)
C     FIND THE COORDINATES TXR AND YXR OF THE MAXIMUM OF THE
C     OBSERVED DATA
      CALL FINDPK(YRR,ICENT,TXR,YXR,NL,NU)
      Y10=0.15*YXR
      Y50=0.5*YXR
C     DEFINITION OF TWO SMALL NUMBERS
      EPS=EPS*YXR
      EPSW=EPSW*YXR
C     FIND POSITIONS M1 AND M2 WITH Y(OBS) APPROX. 0.1*MAX. Y(OBS)
C     AND ALSO MH1 AND MH2 WITH Y(OBS) APPROX. 0.5*MAX Y(OBS)
      DO 325 I=NL,NU
      FI=FLOAT(I)
      YRI=YRR(I)
      IF(FI.LT.TXR.AND.YRI.LT.Y10) M1=I+1
      IF(YRI.GE.Y10) M2=I
      IF(FI.LT.TXR.AND.YRI.LT.Y50) MH1=I+1
      IF(YRI.GE.Y50) MH2=I
  325 CONTINUE
      ID1=ICENT-MH1
      ID2=MH2-ICENT
      IDD1=ICENT-M1
      IDD2=M2-ICENT
C     DETERMINE SOME POINTS WHICH ARE CERTAIN MULTIPLES
C     OF ID1, ID2 AND IDD1, IDD2 AWAY FROM THE CENTER
C     THEY ARE MAINLY USED FOR THE CALCULATION OF STEPS IN THE
C     DEFORMATION PROCEDURES
      M051=ICENT-ID1/2-1
      M052=ICENT+ID2/2+1
      M21=(M1+MH1)/2
      M22=(M2+MH2)/2
      M41=2*M1-M21
      M42=2*M2-M22
      M81=2*M41-ICENT
      M82=2*M42-ICENT
      IDDD1=M41-M81
      IDDD2=M82-M42
      MXM=TXR+0.5
C     FIND POINTS MON1, MON2 AND MON3, MON4 WHICH DEFINE THE RANGE WHERE
C     THE OBSERVED DATA MONOTONICALLY INCREASE OR DECREASE AND ARE
C     POSITIVE. IN THIS RANGE A FIT IS ALSO DONE IN THE DIRECTION
C     OF THE ABSCISSA BESIDE THAT OF THE ORDINATE
C     MON1 AND MON4 ARE MADE TO BE GE M1 AND LE M2
      MON1=M1
CTAM  MON2=MON3=ICENT
      MON3=ICENT
      MON2=MON3
      MON4=M2
      I=MH1
  330 I=I-1
      IF(I.EQ.M1-1) GO TO 331
      YD=YRR(I+1)-YRR(I)
      IF(YD.GT.0.1*YRR(I)) GO TO 330
      MON1=I+1
  331 I=MH1
  332 I=I+1
      IF(I.EQ.ICENT+1) GO TO 333
      YD=YRR(I)-YRR(I-1)
      IF(YD.GT.0.0) GO TO 332
      MON2=I-1
  333 I=MH2
  334 I=I-1
      IF(I.EQ.ICENT-1) GO TO 335
      YD=YRR(I)-YRR(I+1)
      IF(YD.GT.0.0) GO TO 334
      MON3=I+1
  335 I=MH2
  336 I=I+1
      IF(I.EQ.M2+1) GO TO 337
      YD=YRR(I-1)-YRR(I)
      IF(YD.GT.0.1*YRR(I)) GO TO 336
      MON4=I-1
C     DETERMINE PARAMETERS AH1,EX1 AND AH2,EX2 (LEFT AND RIGHT
C     HAND SIDE) OF THE STARTING CURVE DESCRIBED BY THE FORMULA
C     YY = YXR/(1.0+ABS((I-TXR)/AH)**EX)
  337 X1=TXR-FLOAT(M1)
      X2=FLOAT(M2)-TXR
C     AT M1 AND M2 THE STARTING CURVE SHALL RUN TO SOME EXTENT
C     BELOW THE OBSERVED DATA YRR
      YX1=0.8*YRR(M1)/YXR
      YX2=0.8*YRR(M2)/YXR
      MXM2=MXM-2
      MXP=MXM+2
C     AT TXR AND AT MXM2 AND MXP, NEAR THE MAXIMUM WITH YRR LT
C     QQ*YXR, THE STARTING VALUES SHALL BE EQUAL TO THOSE OF YRR
      QQ=0.999
  339 YX01=YRR(MXM2)/YXR
      IF(YX01.LT.QQ) GO TO 342
      MXM2=MXM2-1
      GO TO 339
  342 YX02=YRR(MXP)/YXR
      IF(YX02.LT.QQ) GO TO 343
      MXP=MXP+1
      GO TO 342
  343 X01=TXR-FLOAT(MXM2)
      X02=FLOAT(MXP)-TXR
C     IF THE DATA AROUND THE MAXIMUM ARE STRONGLY SCATTERED
C     THIS IS TAKEN INTO ACCOUNT BY CORRECTIONS OF X01 AND X02
C     THEN THE MAXIMUM OF THE STARTING CURVE IS MADE BROADER
      DREF=(YXR-YRR(MXM2))/FLOAT(MXM-MXM2)
      NDD=0
      MM=MXM-3*ISCF+1
      DO 344 I=MM,MXM2
      DD=YRR(I)-YRR(I-1)
      IF(DD.LE.0.3*DREF) NDD=NDD+1
  344 CONTINUE
      X01=X01+0.5*FLOAT(NDD)
      DREF=(YXR-YRR(MXP))/FLOAT(MXP-MXM)
      NDD=0
      MM=MXM+3*ISCF-1
      DO 345 I=MXP,MM
      DD=YRR(I)-YRR(I+1)
      IF(DD.LE.0.3*DREF) NDD=NDD+1
  345 CONTINUE
      X02=X02+0.5*FLOAT(NDD)
C     CALCULATE THE PARAMETERS OF THE STARTING CURVE
      Q1=1.0/YX01-1.0
      Q2=1.0/YX1-1.0
      EX1=ALOG(Q1/Q2)/ALOG(X01/X1)
      REX=1.0/EX1
      AH1=X1/(Q2**REX)
      Q1=1.0/YX02-1.0
      Q2=1.0/YX2-1.0
      EX2=ALOG(Q1/Q2)/ALOG(X02/X2)
      REX=1.0/EX2
      AH2=X2/(Q2**REX)
C     CALCULATE AND STORE THE STARTING VALUES OF YY
      DO 305 I=1,ISEND
      XI=FLOAT(I)-TXR
      A=AH1
      EX=EX1
      IF(XI.GE.0.0) A=AH2
      IF(XI.GE.0.0) EX=EX2
      XI=ABS(XI)
      Q1=(XI/A)**EX
      Q2=1.0/(1.0+Q1)
  305 YY(I)=YXR*Q2
      TX=TXR
      YX=YXR
C     IN ARRAY PTS THE POSITIONS FIA AND FIB OF THE ''TURNING POINTS''
C     ARE STORED, IN ISUM THE ENDPOINTS NLL AND NUU OF THEIR SUMMATION
C     RANGES AND THE STEPS ISTP
CTAM  IOA=IOB=1
      IOA=1
      IOB=1
      IPTCT=0
CTAM  FSTPA=FSTPB=1.0
      FSTPA=1.0
      FSTPB=1.0
      FIA=TXR
      FIB=TXR
  997 FIA=FIA-FSTPA
      FIB=FIB+FSTPB
      IF(FIA.LT.FLOAT(M81)) IOA=0
      IF(FIB.GT.FLOAT(M82)) IOB=0
      IF(IOA.EQ.0.AND.IOB.EQ.0) GO TO 994
      IPTCT=IPTCT+1
      PTS(IPTCT,1)=FIA
      PTS(IPTCT,2)=FIB
      IFIA=FIA+0.5
      IFIB=FIB+0.5
C     THE POSITIONS FIA AND FIB OF THE ''TURNING POINTS'' FOLLOW
C     ONE ANOTHER BY FIA=FIA-FSTPA AND FIB=FIB+FSTPB
C     THE STEPS SHALL DEPEND ON THE CURVATURE AT FIA AND FIB
C     BECAUSE OF THE POSSIBLY SCATTERED DATA IT IS DIFFICULT
C     TO DETERMINE REALLY THE CURVATURE OF THE OBSERVED CURVE YRR
C     THUS WE USE A FIXED SCHEMA
      IF(FIA.LE.FLOAT(M051)) FSTPA=2.0
      IF(FIA.LE.FLOAT(M21)) FSTPA=1.0
      IF(FIA.LE.FLOAT(M41)) FSTPA=3.0
      FSTPA=AMIN1(FSTPA,FISCF)
      IF(FIB.GE.FLOAT(M052)) FSTPB=2.0
      IF(FIB.GE.FLOAT(M22)) FSTPB=1.0
      IF(FIB.GE.FLOAT(M42)) FSTPB=3.0
      FSTPB=AMIN1(FSTPB,FISCF)
C     FOR THE FIT IN THE DIRECTION OF THE ORDINATE LS-SUMS WILL BE
C     CARRIED OUT FROM NLL TO FIA AND FIB TO NUU
C     THE LENGTHS FILA AND FILB OF THESE INTERVALS SHALL INCREASE WITH
C     DECREASING CURVATURE AND SLOPE, AGAIN ACCORDING TO AN EMPIRICAL
C     SCHEME
      IF(IFIA.GE.M051) FILA=0.5*FLOAT(ID1)
      IF(IFIB.LE.M052) FILB=0.5*FLOAT(ID2)
      IF(IFIA.GE.MH1.AND.IFIA.LT.M051) FILA=FCENT-FIA
      IF(IFIB.LE.MH2.AND.IFIB.GT.M052) FILB=FIB-FCENT
      IF(IFIA.GE.M1.AND.IFIA.LT.MH1) FILA=FLOAT(ID1)
     $+FLOAT(IDD1-2*ID1)*FLOAT(MH1-IFIA)/FLOAT(MH1-M1)
      IF(IFIB.LE.M2.AND.IFIB.GT.MH2) FILB=FLOAT(ID2)
     $+FLOAT(IDD2-2*ID2)*FLOAT(IFIB-MH2)/FLOAT(M2-MH2)
      IF(IFIA.LT.M1) FILA=FLOAT(IDD1-ID1)
     $+FLOAT(IDDD1-IDD1+ID1)*FLOAT(M1-IFIA)/FLOAT(M1-M81)
      IF(IFIB.GT.M2) FILB=FLOAT(IDD2-ID2)
     $+FLOAT(IDDD2-IDD2+ID2)*FLOAT(IFIB-M2)/FLOAT(M82-M2)
      NLL=FIA-FILA
      NUU=FIB+FILB
      NLL=MAX0(NLL,NL)
      NUU=MIN0(NUU,NU)
      IF(IOA.EQ.0) NLL=FIB
      IF(IOB.EQ.0) NUU=FIA+1.0
      ISTPA=0.2*(FILA-20.0)+0.5
      ISTPB=0.2*(FILB-20.0)+0.5
      ISTPA=MAX0(ISTPA,1)
      ISTPB=MAX0(ISTPB,1)
      NLL2=IFIA-20
      NUU2=IFIB+20
      NLL2=MAX0(NLL2,NLL)
      NUU2=MIN0(NUU2,NUU)
      ISUM(IPTCT,1)=NLL
      ISUM(IPTCT,2)=NUU
      ISUM(IPTCT,3)=NLL2
      ISUM(IPTCT,4)=NUU2
      ISUM(IPTCT,5)=ISTPA
      ISUM(IPTCT,6)=ISTPB
      IDEL=3
      FDEL=3.0
      IF(IPTCT.EQ.IPDIM) GO TO 994
      GO TO 997
  994 NC=0
  999 NC=NC+1
C     BEGINNING OF A DEFORMATION CYCLE.
C     ONE CYCLE CONSISTS OF THREE PARTS. IN THE FIRST ONE THE
C     CURVE IS DEFORMED POINTWISE AT ''TURNING POINTS'' WITH
C     ABSCISSA VALUES FIA AND FIB. FIA AND FIB START AT TXR-DELTA
C     AND TXR+DELTA (DELTA=1.0), RESPECTIVELY AND FOLLOW ONE ANOTHER IN
C     DESCENDING AND ASCENDING ORDER UNTIL ICT GT IPTCT
C     OR IOA AND IOB EQ 0
C     IN THE SECOND AND THE THIRD PART THE CURVE IS TRANSLATED
C     ALONG THE ABSCISSA AND SCALED IN THE DIRECTION OF THE ORDINATE
      TXL=TXR-1.0
      TXU=TXR+1.0
      ICT=0
CTAM  IOA=IOB=1
      IOA=1
      IOB=1
      PINF1=1.0
      PINF2=FLOAT(ISEND)
  998 ICT=ICT+1
C     ALL POINTS FIA AND FIB HAVE BEEN CONSIDERED
C     GO TO THE TRANSLATION AND SCALING PROCEDURES
      IF(ICT.GT.IPTCT) GO TO 102
      FIA=PTS(ICT,1)
      FIB=PTS(ICT,2)
C     DETERMINE POINTS OF INFLECTION IF THEY MAY HAVE CHANGED
      IF(FIA.LT.PINF1-2.0*FDEL) GO TO 30
      PINF1=FLOAT(ICENT-1)
      ICM2=ICENT-2*IDEL
      DO 25 J=1,ICM2
      JJ=ICENT-J+1
      D12=YY(JJ)-YY(JJ-IDEL)
      D23=YY(JJ-IDEL)-YY(JJ-2*IDEL)
      PINF1=FLOAT(JJ-IDEL)
      IF(D23.LE.D12) GO TO 30
   25 CONTINUE
   30 IF(FIB.GT.PINF2+2.0*FDEL) GO TO 35
      PINF2=FLOAT(ICENT+1)
      ICM2=ISEND-2*IDEL
      DO 27 J=ICENT,ICM2
      D12=YY(J)-YY(J+IDEL)
      D23=YY(J+IDEL)-YY(J+2*IDEL)
      PINF2=FLOAT(J+IDEL)
      IF(D23.LE.D12) GO TO 35
   27 CONTINUE
C     SPLINE SUBROUTINE INTPOL RETURNS COEFFICIENTS ABCD
C     TO BE USED BY FINTPL
   35 CALL INTPOL(1,ISEND,YY,D,ABCD)
C     IT MAY OCCUR THAT THE CURVE HAS TO BE EXTRAPOLATED AT THE
C     ENDS OF THE RANGE. EXTRAPOLATION IS DONE ACCORDING TO
C     YY = YXR/(1.0+ABS((ALPHA*ABS(I-TXR)-BETA)/AH)**EX)
C     THE PARAMETERS ALPH1,BETA1 AND ALPH2,BETA2 HAVE TO BE DETERMINED
      IEXPO1=1
      Q1=YY(1)
      IF(Q1.LE.EPS) IEXPO1=0
      IF(IEXPO1.EQ.0) GO TO 40
      Q2=YY(ISP1)
      Q1=(YX-Q1)/Q1
      Q2=(YX-Q2)/Q2
      Q1=Q1**(1.0/EX1)
      Q2=Q2**(1.0/EX1)
      X1=TX-1.0
      X2=TX-FLOAT(ISP1)
      X2X1=X2-X1
      ALPH1=AH1*(Q2-Q1)/X2X1
      BETA1=AH1*(X1*Q2-X2*Q1)/X2X1
   40 IEXPO2=1
      Q1=YY(ISEND)
      IF(Q1.LE.EPS) IEXPO2=0
      IF(IEXPO2.EQ.0) GO TO 41
      Q2=YY(IEMS)
      Q1=(YX-Q1)/Q1
      Q2=(YX-Q2)/Q2
      Q1=Q1**(1.0/EX2)
      Q2=Q2**(1.0/EX2)
      X1=FLOAT(ISEND)-TX
      X2=FLOAT(IEMS)-TX
      X2X1=X2-X1
      ALPH2=AH2*(Q2-Q1)/X2X1
      BETA2=AH2*(X1*Q2-X2*Q1)/X2X1
C     BEGINNING OF THE DEFORMATION PROCEDURES APPLIED TO THE
C     PARTS OF THE CURVE WITH I LT FIA+DELTA AND I GT FIB-DELTA
   41 IFIA=FIA+0.5
      IFIB=FIB+0.5
C     CURRENT FUNCTION VALUES YYA, YYB AT IFIA AND IFIB
      YYA=YY(IFIA)
      YYB=YY(IFIB)
C     OUTSIDE THE RANGE LIMITED BY M1 AND M2 THE FUNCTION VALUES
C     ARE TESTED IF THEY ARE NOT TOO SMALL. IF THEY ARE
C     IOA OR IOB ARE SET TO ZERO. FROM THAT POINTS ON THE
C     CURVE WILL BE NO MORE DEFORMED
      IF(IFIA.GE.M1.OR.IOA.EQ.0) GO TO 50
      IF(YYA.LE.EPS) IOA=0
   50 IF(IFIB.LE.M2.OR.IOB.EQ.0) GO TO 60
      IF(YYB.LE.EPS) IOB=0
   60 IF(IOA.EQ.0.AND.IOB.EQ.0) GO TO 102
C     THE CURVE HAS TO BE DEFORMED ACCORDING TO
C     YY(NEW)(I) = YY(OLD)(T(I))
C     THE FUNCTION T(I) IS DEPENDING ON ONE PARAMETER,AA
C     AA HAS TO BE DETERMINED IN PRINCIPLE
C     BY MINIMIZING SUM(WI*(Y(OBS)(I)-YY(OLD)(T(I)))**2)
C     OUTSIDE THE MONOTONIC PARTS OF THE OBSERVED CURVE
C     AND SUM(WI*(T(OBS)(I)-T(I))**2) WITHIN THEM
C     (Y(OBS)(I)=YRR(I), T(OBS)(I)=TI)
C     THE ''OBSERVED'' ABSCISSA VALUES T(OBS)(I) ARE OBTAINED
C     BY LINEAR INTERPOLATION OF YY(OLD)
C     ACCORDING TO YY(OLD)(T(OBS)(I)) = Y(OBS)(I)
C     FOR THE DETERMINATION OF AA T(I) IS ASSUMED TO HAVE THE FORM
C     T(I) = I+AA1*(I-FIA) OR T(I) = I+AA2*(I-FIB)
CTAM  SUM1=SUM2=SUM3=SUM4=0.0
      SUM1=0.0
      SUM2=0.0
      SUM3=0.0
      SUM4=0.0
CTAM  S1=S2=S3=S4=0.0
      S1=0.0
      S2=0.0
      S3=0.0
      S4=0.0
CTAM  IA1CT=IA2CT=IY1CT=IY2CT=0
      IA1CT=0
      IA2CT=0
      IY1CT=0
      IY2CT=0
      IEND=0
      NLL=ISUM(ICT,1)
      NUU=ISUM(ICT,2)
      NLL2=ISUM(ICT,3)
      NUU2=ISUM(ICT,4)
      IF(IOA.EQ.0) NLL=IFIB-1
      IF(IOB.EQ.0) NUU=IFIA+1
      IF(IOA.EQ.0) NLL2=NLL
      IF(IOB.EQ.0) NUU2=NUU
      ISTPA=ISUM(ICT,5)
      ISTPB=ISUM(ICT,6)
      IST=ISTPA
      I=NLL-IST
   61 I=I+IST
      IF(I.GT.NUU) GO TO 90
      IF(I.GE.NLL2) IST=1
      IF(I.GE.NUU2) IST=ISTPB
      YRI=YRR(I)
   62 FI=FLOAT(I)
      IF(FI.GT.FIA.AND.FI.LT.FIB) GO TO 90
      YI=YY(I)
      WI=FLOAT(IST)
      WI=WI*(1.0+ABS(YRI-Y50))
      IF(FI.LE.FIA) ETA=FI-FIA
      IF(FI.GE.FIB) ETA=FI-FIB
      IF(IEND.NE.0) GO TO 67
      IF(I.GE.MON1.AND.I.LE.MON2) GO TO 67
      IF(I.GE.MON3.AND.I.LE.MON4) GO TO 67
      IF(FI.GE.FIB) GO TO 66
C     OUTSIDE THE MONOTONIC PARTS OF THE OBSERVED CURVE
C     CONSIDER THE DEVIATIONS YRI-YI WEIGHTED BY THE RECIPROCAL
C     DISTANCE OF FI FROM FIA+1.0 OR FIB-1.0, RESPECTIVELY
      SUM1=SUM1+WI*(YRI-YI)/(1. - ETA)
      SUM2=SUM2+WI
      IY1CT=IY1CT+1
      GO TO 90
   66 SUM3=SUM3+WI*(YRI-YI)/(1.+ETA)
      SUM4=SUM4+WI
      IY2CT=IY2CT+1
      GO TO 90
C     IN THE MONOTONIC PARTS OF THE OBSERVED CURVE CONSIDER
C     THE DEVIATIONS IN THE DIRECTION OF THE ABSCISSA
   67 KB=I
      IF(FI.GE.FIB) GO TO 94
   92 IF(YY(KB).GE.YRI.AND.YY(KB-1).LE.YRI) GO TO 93
      IF(KB.EQ.ICENT) GO TO 93
      IF(KB.EQ.NL+1) GO TO 93
      IF(YRI.GT.YI) KB=KB+1
      IF(YRI.LT.YI) KB=KB-1
      GO TO 92
   94 IF(YY(KB-1).GE.YRI.AND.YY(KB).LE.YRI) GO TO 93
      IF(KB.EQ.ICENT+1) GO TO 93
      IF(KB.EQ.NU) GO TO 93
      IF(YRI.GT.YI) KB=KB-1
      IF(YRI.LT.YI) KB=KB+1
      GO TO 94
   93 KA=KB-1
      YA=YY(KA)
      YB=YY(KB)
      TI=FLOAT(KA)
      YBA=YB-YA
      IF(ABS(YBA).GT.EPS) TI=TI+(YRI-YA)/YBA
      IF(FI.LE.FIA) TI=AMIN1(TI,FCENT)
      IF(FI.GE.FIB) TI=AMAX1(TI,FCENT)
      DTI=TI-FI
      IF(FI.GE.FIB) GO TO 95
C     CONCERNS FIT IN THE DIRECTION OF THE ABSCISSA
C     LEFT HALF OF THE CURVE
      S1=S1+WI*DTI*ETA
      S2=S2+WI*ETA*ETA
      IA1CT=IA1CT+1
      IF(IEND.EQ.1) GO TO 190
      GO TO 90
C     RIGHT HALF
   95 S3=S3+WI*DTI*ETA
      S4=S4+WI*ETA*ETA
      IA2CT=IA2CT+1
      IF(IEND.EQ.2) GO TO 191
   90 IF(I.LT.NUU) GO TO 61
      IF(IY1CT.EQ.0) GO TO 190
C     THE MEAN OF THE YRI-YI OUTSIDE THE MONOTONIC PARTS IS
C     ADDED TO YY AT IFIA-1 OR IFIB+1 AND THE RESULT IS
C     HANDLED LIKE AN ADDITIONAL OBSERVATION IN THE
C     MONOTONIC PARTS
      DEL=SUM1/SUM2
      I=IFIA-1
      YRI=YY(I)+DEL
      IST=1
      IEND=1
      GO TO 62
  190 IF(IY2CT.EQ.0) GO TO 191
      DEL=SUM3/SUM4
      I=IFIB+1
      YRI=YY(I)+DEL
      IST=1
      IEND=2
      GO TO 62
CT191 AA1=AA2=0.0
  191 AA1=0.0
      AA2=0.0
      IF(IA1CT.GT.0) AA1=S1/S2
      IF(IA2CT.GT.0) AA2=S3/S4
C     T(I) IS DEFINED BY (AT THE RIGHT HALF OF THE CURVE):
C     T(I) = I FOR I LT FIB-DELTA
C     T(I) = I+A32*(I-FIB+DELTA)**3+A42*(I-FIB+DELTA)**4
C     FOR I GE FIB-DELTA AND I LE FIB+DELTA
C     T(I) = I+AA2*(I-FIB) FOR I GT FIB+DELTA
C     WITH A32 = 0.25*AA2/DELTA**2 AND A42 = -0.0625*AA2/DELTA**3
C     (DELTA=1.0)
C     AA1 AND AA2 HAVE TO FULFILL SOME RESTRICTIONS WHICH
C     MAINTAIN THE CORRECT SIGN OF SLOPE AND CURVATURE IN THE DIFFERENT
C     PARTS OF THE CURVE
      IF(AA1.EQ.0.0) GO TO 84
      AA1=AMAX1(AA1,-0.8)
      IF(IFIA.EQ.ICENT) GO TO 84
      ID=MIN0(IDEL,ICENT-IFIA)
      D21=YY(IFIA)-YY(IFIA+ID)
      D32=YY(IFIA-ID)-YY(IFIA)
      AEXTR=(D21-D32)/D32
      AEXTR=0.4*AEXTR
      IF(FIA.GT.PINF1+FDEL) GO TO 181
      IF(FIA.LT.PINF1-FDEL) GO TO 182
      AEXTR=ABS(AEXTR)
      IF(AA1.GT.0.0) AA1=AMIN1(AEXTR,AA1)
      IF(AA1.LT.0.0) AA1=AMAX1(-AEXTR,AA1)
      GO TO 84
  181 AA1=AMAX1(AEXTR,AA1)
      GO TO 84
  182 AA1=AMIN1(AEXTR,AA1)
      GO TO 84
   84 IF(AA2.EQ.0.0) GO TO 85
      AA2=AMAX1(AA2,-0.8)
      IF(IFIB.EQ.ICENT) GO TO 85
      ID=MIN0(IDEL,IFIB-ICENT)
      D21=YY(IFIB)-YY(IFIB-ID)
      D32=YY(IFIB+ID)-YY(IFIB)
      AEXTR=(D21-D32)/D32
      AEXTR=0.4*AEXTR
      IF(FIB.LT.PINF2-FDEL) GO TO 184
      IF(FIB.GT.PINF2+FDEL) GO TO 185
      AEXTR=ABS(AEXTR)
      IF(AA2.GT.0.0) AA2=AMIN1(AEXTR,AA2)
      IF(AA2.LT.0.0) AA2=AMAX1(-AEXTR,AA2)
      GO TO 85
  184 AA2=AMAX1(AEXTR,AA2)
      GO TO 85
  185 AA2=AMIN1(AEXTR,AA2)
      GO TO 85
   85 IF(AA1.EQ.0.0.AND.AA2.EQ.0.0) GO TO 998
C     AA FULFILLS NOW THE RESTRICTIONS
      A31=0.25*AA1
      A32=0.25*AA2
      A41=0.25*A31
      A42=-0.25*A32
C     NOW WE HAVE THE EVENTUAL PARAMETERS AA1,AA2 AND THUS
C     A31, A32 AND A41, A42 DETERMINING T(I)
C     YY(NEW) CAN BE CALCULATED BY YY(NEW)(I) = YY(OLD)(T(I))
      FIAMD=FIA-1.0
      FIAPD=FIA+1.0
      FIBMD=FIB-1.0
      FIBPD=FIB+1.0
      DO 99 I=1,ISEND
      FI=FLOAT(I)
      IF(FI.GE.FIAPD.AND.FI.LE.FIBMD) GO TO 99
      IF(FI.GT.FIAMD) GO TO 97
      XII=FI-FIA
      TI=FI+AA1*XII
      GO TO 100
   97 IF(FI.GE.FIAPD) GO TO 98
      XII=FI-FIAPD
      XII3=XII**3
      XII4=XII*XII3
      TI=FI+A31*XII3-A41*XII4
      GO TO 100
   98 IF(FI.GE.FIBPD) GO TO 101
      XII=FI-FIBMD
      XII3=XII**3
      XII4=XII*XII3
      TI=FI+A32*XII3+A42*XII4
      GO TO 100
  101 XII=FI-FIB
      TI=FI+AA2*XII
  100 IF(TI.GT.TX) GO TO 110
      IF(IEXPO1.EQ.0) GO TO 115
      IF(TI.GE.1.0) GO TO 115
C     EXTRAPOLATION AT THE LOWER END OF THE RANGE IS NEEDED
      XI=TX-TI
      Q=(ALPH1*XI-BETA1)/AH1
      Q=ABS(Q)**EX1
      YY(I)=YX/(1.0+Q)
      GO TO 99
  110 IF(IEXPO2.EQ.0) GO TO 115
      IF(TI.LE.FLOAT(ISEND)) GO TO 115
C     EXTRAPOLATION AT THE UPPER END
      XI=TI-TX
      Q=(ALPH2*XI-BETA2)/AH2
      Q=ABS(Q)**EX2
      YY(I)=YX/(1.0+Q)
      GO TO 99
C     EVALUATION OF Y(OLD) AT TI BY MEANS OF THE COEFFICIENTS
C     ABCD GIVES YY(NEW)
  115 CALL FINTPL(1,ISEND,ABCD,TI,YY(I))
   99 CONTINUE
C     END OF THE DEFORMATION PROCEDURES FOR THE PARTS OF THE CURVE
C     TO THE LEFT OF THE TURNING POINT AT FIA AND TO THE RIGHT OF
C     THE TURNING POINT AT FIB
C     GO TO THE NEXT TWO POINTS
      GO TO 998
  102 IF(NC.EQ.NCC) GO TO 103
C     TRANSLATION OF THE CURVE BY DTIM AND SCALING IN THE DIRECTION
C     OF THE ORDINATE BY A
C     IF NC LT NCC OR ICVT EQ 0: THE COORDINATES OF THE MAXIMUM OF Y(CAL
C     ARE MADE EQUAL TO THESE OF Y(OBS)
      CALL FINDPK(YY,MXM,TX,YX,NL,NU)
      DTIM=TX-TXR
      A=YXR/YX
      GO TO 307
C     IF NC EQ NCC OR ICVT EQ 1: BY MEANS OF OBSERVED ABSCISSA VALUES IN
C     THE MONOTONIC PARTS OF THE CURVE A TRANSLATION DTIM IS
C     CALCULATED TO PERFORM A FIT IN THE DIRECTION OF THE ABSCISSA
CT103 S1=S2=0.0
  103 S1=0.0
      S2=0.0
      DO 308 I=MON1,MON4,ISCF
      IF(I.GT.MON2.AND.I.LT.MON3) GO TO 308
      FI=FLOAT(I)
      IF(FI.GT.TXL.AND.FI.LT.TXU) GO TO 308
      YI=YY(I)
      YRI=YRR(I)
      WI=EPSW
      IF(YRI.GT.0.0) WI=WI+YRI
      KB=I
      IF(I.GE.MON3) GO TO 310
  309 IF(YY(KB).GE.YRI.AND.YY(KB-1).LE.YRI) GO TO 311
      IF(KB.EQ.ICENT) GO TO 311
      IF(KB.EQ.NL+1) GO TO 311
      IF(YRI.GT.YI) KB=KB+1
      IF(YRI.LT.YI) KB=KB-1
      GO TO 309
  310 IF(YY(KB-1).GE.YRI.AND.YY(KB).LE.YRI) GO TO 311
      IF(KB.EQ.ICENT+1) GO TO 311
      IF(KB.EQ.NU) GO TO 311
      IF(YRI.GT.YI) KB=KB-1
      IF(YRI.LT.YI) KB=KB+1
      GO TO 310
  311 KA=KB-1
      YA=YY(KA)
      YB=YY(KB)
      TI=FLOAT(KA)
      YBA=YB-YA
      IF(ABS(YBA).GT.EPS) TI=TI+(YRI-YA)/YBA
      IF(I.LE.MON2) TI=AMIN1(TI,FCENT)
      IF(I.GE.MON3) TI=AMAX1(TI,FCENT)
      DTI=TI-FI
      S1=S1+WI*DTI
      S2=S2+WI
  308 CONTINUE
      DTIM=S1/S2
C     CALL OF INTPOL TO RETURN COEFFICIENTS ABCD TO BE USED
C     BY FINTPL
  307 CALL INTPOL(1,ISEND,YY,D,ABCD)
C     AS BEFORE, FOR EXTRAPOLATION PARAMETERS ALPH1,BETA1 AND
C     ALPH2,BETA2 HAVE TO BE CALCULATED
      IEXPO1=1
      Q1=YY(1)
      IF(Q1.LE.EPS) IEXPO1=0
      IF(IEXPO1.EQ.0) GO TO 340
      Q2=YY(ISP1)
      Q1=(YX-Q1)/Q1
      Q2=(YX-Q2)/Q2
      Q1=Q1**(1.0/EX1)
      Q2=Q2**(1.0/EX1)
      X1=TX-1.0
      X2=TX-FLOAT(ISP1)
      X2X1=X2-X1
      ALPH1=AH1*(Q2-Q1)/X2X1
      BETA1=AH1*(X1*Q2-X2*Q1)/X2X1
  340 IEXPO2=1
      Q1=YY(ISEND)
      IF(Q1.LE.EPS) IEXPO2=0
      IF(IEXPO2.EQ.0) GO TO 341
      Q2=YY(IEMS)
      Q1=(YX-Q1)/Q1
      Q2=(YX-Q2)/Q2
      Q1=Q1**(1.0/EX2)
      Q2=Q2**(1.0/EX2)
      X1=FLOAT(ISEND)-TX
      X2=FLOAT(IEMS)-TX
      X2X1=X2-X1
      ALPH2=AH2*(Q2-Q1)/X2X1
      BETA2=AH2*(X1*Q2-X2*Q1)/X2X1
C     CURVE HAS TO BE TRANSLATED BY DTIM
  341 DO 104 I=1,ISEND
      TI=FLOAT(I)+DTIM
      IF(TI.GT.TX) GO TO 118
      IF(IEXPO1.EQ.0) GO TO 120
      IF(TI.GE.1.0) GO TO 120
C     EXTRAPOLATION NEEDED AT THE LOWER END
      XI=TX-TI
      Q=(ALPH1*XI-BETA1)/AH1
      Q=ABS(Q)**EX1
      YY(I)=YX/(1.0+Q)
      GO TO 104
  118 IF(IEXPO2.EQ.0) GO TO 120
      IF(TI.LE.FLOAT(ISEND)) GO TO 120
C     EXTRAPOLATION AT THE UPPER END
      XI=TI-TX
      Q=(ALPH2*XI-BETA2)/AH2
      Q=ABS(Q)**EX2
      YY(I)=YX/(1.0+Q)
      GO TO 104
C     EVALUATION OF YY(OLD) AT I+IDIM GIVES YY(NEW)
  120 CALL FINTPL(1,ISEND,ABCD,TI,YY(I))
  104 CONTINUE
      TX=TX-DTIM
      IF(NC.LT.NCC.AND.ICVT.EQ.0) GO TO 107
C     IF NC EQ NCC OR ICVT EQ 1 THE SCALING FACTOR A IS DETERMINED SUCH
C     THE WEIGHTED LS-SUM OF Y(OBS)-Y(CALC)(OLD) IS MINIMIZED
CTAM  SUM1=SUM2=0.0
      SUM1=0.0
      SUM2=0.0
      DO 105 I=NL,NU
      YI=YY(I)
      YRI=YRR(I)
      WI=EPSW
      IF(YRI.GT.0.0) WI=WI+YRI
      SUM1=SUM1+WI*YRI*YI
  105 SUM2=SUM2+WI*YI*YI
      A=SUM1/SUM2
  107 DO 106 I=1,ISEND
  106 YY(I)=A*YY(I)
      YX=A*YX
C     CALCULATE R-VALUE
      RVALO=RVAL
      SUM1=0.0
      SUM2=0.0
      II=1-ISCF
      DO 121 I=1,201
      II=II+ISCF
      AO=ABS(YRR(II))
      IF(AO.LT.EPS)  GO TO 121
      AC=YY(II)
      SUM1=SUM1+ABS(AO-AC)
      SUM2=SUM2+AO
  121 CONTINUE
      RVAL=SUM1/SUM2
      IF(IPRI.EQ.1) WRITE (NTOUT,7777)RVAL
 7777 FORMAT(1x,' RVAL = ',F10.3)
      IF(ICYCA.EQ.1) GO TO 130
      DRVAL=ABS(RVALO-RVAL)
      IF(ICVT.EQ.1) GO TO 122
      IF(DRVAL.GT.1.0E-3) GO TO 130
      ICVT=1
      IF(NC.LT.NCC) GO TO 103
  122 WRITE (NTOUT,1000)NC,RVAL
 1000 FORMAT(/1x,'CONVERGENCE AFTER',I3,' CYCLES'/
     $'R-VALUE IS ',F5.3)
      GO TO 131
C     GO BACK TO THE BEGINNING OF THE NEXT CYCLE
  130 IF(NC.LT.NCC) GO TO 999
C     THE CALCULATED CURVE IS RETURNED IN ARRAY Y OF LENGTH 201,
C     AGAIN
  131 NL=NLH
      NU=NUH
      II=1-ISCF
      DO 109 I=1,201
      II=II+ISCF
  109 Y(I)=YY(II)
C     PRINT FINAL R-VALUE
      WRITE (NTOUT,1010)NC,RVAL
 1010 FORMAT(1x,'FINAL R-VALUE AFTER',I4,' CYCLES: ',F5.3)
      RETURN
      END
      SUBROUTINE FINDPK(Y,MX,TX,YX,NL,NU)
C     DETERMINES THE COORDINATES TX,YX OF THE MAXIMUM OF Y
      DIMENSION Y(1),ABCD(4,601),Y1(601)
      CALL INTPOL(NL,NU,Y,Y1,ABCD)
      TX=FLOAT(MX)
      DTMIN=0.00001
      DT=1.0
   20 DT=0.1*DT
      TL=TX-DT
      TR=TX+DT
      CALL FINTPL(NL,NU,ABCD,TL,FL)
      CALL FINTPL(NL,NU,ABCD,TX,FX)
      CALL FINTPL(NL,NU,ABCD,TR,FR)
    1 IF(FL.LE.FX.AND.FR.LE.FX) GO TO 10
      IF(FL.GT.FX) GO TO 5
      TL=TX
      FL=FX
      TX=TR
      FX=FR
      TR=TR+DT
      CALL FINTPL(NL,NU,ABCD,TR,FR)
      GO TO 1
    5 TR=TX
      FR=FX
      TX=TL
      FX=FL
      TL=TL-DT
      CALL FINTPL(NL,NU,ABCD,TL,FL)
      GO TO 1
   10 IF(FL.EQ.FX.AND.FR.EQ.FX) GO TO 15
      IF(FL.LT.FX.AND.FR.LT.FX) GO TO 15
      IF(FL.LT.FX) TX=0.5*(TX+TR)
      IF(FR.LT.FX) TX=0.5*(TL+TX)
   15 IF(DT.GT.DTMIN) GO TO 20
      CALL FINTPL(NL,NU,ABCD,TX,YX)
      RETURN
      END
