      PROGRAM SPRING
C
C
C     *********************
C     *                   *
C     *    S P R I N G    *
C     *                   *
C     *********************
C
C     THIS PROGRAM PERFORMS A PROFILE ANALISIS USING THE STANDARD
C     PEAK PROFILE FUNCTION DETERMINED BY PROGRAM PEAK. IT DETERMINES
C     THE DEPENDENCE ON 2 THETA OF THE HALF WIDTH AND THE PEAK
C     ASYMMETRY. IT ALSO GENERATES INDICES, INTERPRETS FREE FORMAT
C     FORM FACTOR CARDS AND WRITES THE INPUT CARDS FOR 'DATRDN' OF
C     THE XRAY PROFILE FITTING AND STRUCTURE REFINEMENT PROGRAM.
C
C     SPRING IS A MODIFICATION OF THE PROGRAM IDEX (H. MOECK, INSTITUT
C     FUER KRISTALLOGRAPHIE, ETH, ZUERICH, JANUARY 1973). IT WAS
C     WRITTEN BY CH. BAERLOCHER, INSTITUT FUER KRISTALLOGRAPHIE UND
C     PETROGRAPHIE, ETH-ZENTRUM, CH-8092 ZURICH, JANUARY 1979.
C     MODIFIED MAY .
C
      CHARACTER*1 COL,NL,ITIT,ICOMP
      character*4 mcent,itype,isymb
      integer*4 index,ispace
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      COMMON /IC/ IC(13)
      COMMON /PA/ ICURV,IHAIN,IHAOUT,IHW,IPAS,IWHA,JL,JU,IPRANA,
     $            CTMIN,HWMX,QJT,QINT,TSTART,TSTEP,
     $            ZP,HWAR(100),PASAR(100)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF
      COMMON INDEX(3000),QS(3000),mcent,itype(80),isymb(1440)
      EQUIVALENCE (INDEX(2),ISPACE)
      character*9 DTE
C
C     DEFINE FILE NAMES
C
      open(8,file='c:\xrs\tape.8')

      NTIN = 5
      NTOUT = 6
      ISYMF = 8
      ICURV = 12
      IPROF = 14
      IHAIN = 24
      IHAOUT = 25
      NTCRD = 35
C
  100 CALL CARDIN
      IF(ISPACE.EQ.0)  GO TO 200
      CALL MLAUE
C
C     READ SYMMETRY DATA FROM FILE
C
      CALL SYMCRD
  200 IF(IDEX.EQ.0)  GO TO 300
      CALL CODE
C
C     PRINT LISTING OF INPUT DATA
C
  300 CALL OUTDAT
      IF(LCRD.EQ.0)  GO TO 350
C

C     PUNCH DATRDN CARDS
C
      CALL OUTCRD (1)
C
C
  350 IF(IPRANA.EQ.0)  GO TO 400
C     MAKE A PROFILE ANALYSIS (HALF WIDTH, PEAK ASYMMETRY
C
      CALL PROFAN
      IF(IPRANA.EQ.0)  GO TO 400
  400 CALL OUTCRD(2)
C
C     SET UP MILLER INDICES
C
      IF(IDEX.EQ.0)  GO TO 100
      CALL HKL
      IF(LCRD.EQ.0)  GO TO 450
      CALL OUTCRD(3)
C
C     PRINT REFLECTIONS IN INCREASING ORDER OF 2 THETA
C
  450 CALL OUTHKL
      GO TO 100
      END

      SUBROUTINE CARDIN
      CHARACTER*1 COL,NL,ITIT,ICOMP
      character*4 mcent,itype,isymb
      integer*4 index,iext,ispace
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL

      COMMON /IC/ IC(13)
      COMMON /PA/ ICURV,IHAIN,IHAOUT,IHW,IPAS,IWHA,JL,JU,IPRANA,
     $            CTMIN,HWMX,QJT,QINT,TSTART,TSTEP,
     $            ZP,HWAR(100),PASAR(100)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000), QS(3000),mcent,itype(20,4),isymb(1440)
      DIMENSION IPFX(21),FX(1000),NC(13)
      EQUIVALENCE (INDEX(1),IEXT),(INDEX(2),ISPACE),(INDEX(2065),NC(1))
      EQUIVALENCE (QS(81),IPFX(1)),(QS(101),FX(1))
C
C     SET DEFAULT VALUES
C
      IBS = 10
      ICELL = 0
      IEXT = 1
      IPAGE = 0
      IDEX = 1
      IPRANA = 1
      IHW = 0
      IPAS = 0
      ISYST = 0
      ISPACE = 0
      IP = 1
      IWHA = 0
      IXN = 1
      LASTC = 0
      LAUE = 0
      LCRD = 1
      LISTH = 0
      NF = 0
      IDIMTY = 12
      NCHAR = 6
      XLAMDA = 1.54050
      THMAX = 100.
      THMIN = 1.
      POLRA =  .915
      RANGE = -8.
      RD = .01745329252
      STEP = 0.1
C     PARAMETER FOR PEAK ASYMMETRY
      CA1 = 0.001
      CA2 = 0.002
      CA3 = 0.002
C     PARAMETERS FOR HALF WIDTH
      WDU = .0015
      WDV = .0015
      WDW = .002
C     DEFAULT VALUES FOR PROFAN
C
C     MINIMUM NUMBER OOF COUNTS FOR ACCEPTANCE OF A PEAK
      CTMIN = 200.
C     PERCENTAGE OF THE TOTAL USABLE PART OF AN ACCEPTED PEAK
C     BELOW THIS VALUE NO HWW OR PAS CALCULATIONS ARE MADE
      ZP = .1
C     UPPER LIMIT OF HALF WIDTH HW. IF FOR A PEAK ALL CALCULATED
C     HW VALUES ECCEED THIS LIMIT, THE PEAK IS REJECTED
      HWMX = .6
C
      DO 1 I=1,3
    1 POV(I) = 0.
      PREFOF = 0.
      DO 2 I=1,13
    2 IC(I) = 0
      DO 3 I = 1,74
    3 ITIT(I) = ' '
      DO 4 I = 1,6
    4 ICOMP(I) =' '

C
C     READ AND PRINT CONTROL CARDS
C
    5 READ(NTIN,1000,END=990) COL
CTAM  IF(EOF(NTIN)) 990,10
   10 IF(COL(1).EQ.' '.AND.COL(3).EQ.' ') GO TO 30
      LASTC = 0
      IF(COL(1).EQ.'L'.AND.COL(3).EQ.'B')  GO TO 50
      IF(COL(1).EQ.'E'.AND.COL(3).EQ.'D')  GO TO 900
      IF(COL(1).EQ.'F'.AND.COL(3).EQ.'N')  GO TO 990
      CALL FREDA (7,80)
      IF(COL(1).EQ.'S'.AND.COL(3).EQ.'R')  GO TO 100
      IF(COL(1).EQ.'W'.AND.COL(3).EQ.'V')  GO TO 200
      IF(COL(1).EQ.'2'.AND.COL(3).EQ.'H')  GO TO 250
      IF(COL(1).EQ.'C'.AND.COL(3).EQ.'L')  GO TO 300
      IF(COL(1).EQ.'E'.AND.COL(3).EQ.'T')  GO TO 400
      IF(COL(1).EQ.'S'.AND.COL(3).EQ.'A')  GO TO 420
      IF(COL(1).EQ.'L'.AND.COL(3).EQ.'U') GO TO 450
      IF(COL(1).EQ.'F'.AND.COL(6).EQ.'X')  GO TO 460
      IF(COL(1).EQ.'H'.AND.COL(3).EQ.'L')  GO TO 570
      IF(COL(1).EQ.'P'.AND.COL(4).EQ.'K')  GO TO 600
      IF(COL(1).EQ.'P'.AND.COL(4).EQ.'F')  GO TO 620
      IF(COL(1).EQ.'P'.AND.COL(4).EQ.'V')  GO TO 700
C
C     CONTINUATION CARD
C
C     LASTC = 1    FORMFX CARD
C
   30 CALL FREDA (4,80)
      IF(LASTC-1) 850,460,850
C
C     LABEL CARD
C
   50 K = 0
      DO 60 I=7,80
      IF(K.GT.0) GO TO 55
      IF(COL(I).EQ.' ') GO TO 60
   55 K = K + 1
      ITIT(K) = COL(I)
   60 CONTINUE
      GO TO 5
C
C     SPRING CARD
C     FIRST WORD: COMPOUND IDENTIFICATION
C     ACCEPTED KEY WORDS: LISTH,NOEXT,NOIDEX,NOCRD,
C     OLDWD,OLDPA,RAWWDP
C
  100 IF(KL.LE.0)  GO TO 5
      DO 105 I=1,6
  105 ICOMP(I) = NL(1,I)
      IF(KL.EQ.1) GO TO 5
      DO 190 I=2,KL
      IF(NL(I,1).EQ.'N') GO TO 150
      IF(NL(I,1).EQ.'L')  GO TO 110
      IF(NL(I,1).EQ.'R')  GO TO 130
      IF(NL(I,1).EQ.'O')  GO TO 180
      GO TO 190
  110 IF(NL(I,3).NE.'S')  GO TO 190
      LISTH = 1
      GO TO 190
  130 IWHA = -1
      GO TO 190
  150 IF(NL(I,3).EQ.'E')  GO TO 160
      IF(NL(I,3).EQ.'I')  GO TO 165
      IF(NL(I,3).EQ.'C')  GO TO 170
      GO TO 190
  160 IEXT = 0
      GO TO 190
  165 IDEX = 0
      GO TO 190
  170 LCRD = 0
      GO TO 190
  180 IF(NL(I,5).NE.'W')  GO TO 185
      IHW = 1
      GO TO 190
  185 IF(NL(I,5).NE.'P')  GO TO 190
      IPAS = 1
      GO TO 190

  190 CONTINUE
      GO TO 5
C
C     WAVLEN CARD
C
  200 NTHET = 1
      IF(KL.LT.1)  GO TO 210
      IF(NL(KL,1).NE.'P')  GO TO 205
      POLRA = FN(KN)
      KL = KL - 1
      KN = KN -1
      IF(KL.LT.1)  GO TO 210
  205 CALL WAVLEN (NTHET)
  210 IF(KN.EQ.NTHET) THMAX = FN(NTHET)
      IF(THMAX.GT.179.99) THMAX = 179.99
      GO TO 5
C
C     2 THETA CARD
C
  250 IF(KN-1)  5,260,255
  255 THMIN = FN(1)
      THMAX = FN(2)
      GO TO 5
  260 THMAX = FN(1)
      GO TO 5
C
C     CELL CARD
C
  300 CALL CELL
      ICELL = 1
      GO TO 5
C
C     EXTICN CARD
C
  400 IF(KN.EQ.0)  GO TO 5
      IEXT = 0
      KE = 13
      IF(KN.LT.13) KE = KN
      DO 410 I=1,KE
      IC(I) = FN(I)
  410 NC(I) = IC(I)
      GO TO 5
C
C     SPACE GROUP CARD
C
  420 ISPACE = FN(1)
      GO TO 5
C
C     LAUE CARD
C
  450 IF(KN.GE.1) LAUE = FN(1)
      GO TO 5
C
C     FORMFX CARD
C
  460 LASTC = 1
      IF(KL.EQ.1)  GO TO 465
      IF(NF)  860,860,485
  465 IF(NF.EQ.0)  GO TO 475
      DO 470 I=1,4
      IF(ITYPE(NF,I).NE.NL(1,I))  GO TO 475
  470 CONTINUE
C     SAME ATOM TYPE
      GO TO 485
C     NEW ATOM TYPE
  475 NF = NF + 1
      IF(NF.GT.IDIMTY)  GO TO 865
      IPFX(NF) = IP
      DO 480 I=1,4
  480 ITYPE(NF,I) = NL(1,I)
  485 IF(KN.EQ.0)  GO TO 850
      JUNK = MOD(KN,2)
      IF(JUNK.NE.0)  GO TO 850
  490 DO 495 K=1,KN,2
      FX(IP) = FN(K)
      IP = IP + 1
      FX(IP) = FN(K+1)
  495 IP = IP + 1
      GO TO 5
C
C
C     HALFWD CARD
C
  570 IF(KL.EQ.0)  GO TO 575
      IF(NL(1,1).NE.'R')  GO TO 575
      RANGE = FN(KN)
      KN = KN-1
  575 IF(KN.EQ.0)  GO TO 5
      IHW = 2
      WDV = 0.0
      WDW = 0.0
      IF(KN-2) 590,585,580
  580 WDW = FN(3)
  585 WDV = FN(2)
  590 WDU = FN(1)
      GO TO 5
C
C     PEAKAS - CARD
C
  600 IPAS = 2
      IF(KN.EQ.0)  GO TO 5
      CA2 = 0.0
      CA3 = 0.0
      IF(KN-2)  615,610,605
  605 CA3 = FN(3)
  610 CA2 = FN(2)
  615 CA1 = FN(1)
      GO TO 5
C
C     PROFAN CARD
C
  620 IF(KN.EQ.0)  GO TO 5
      IF(KN.GT.3)  GO TO 850
      GO TO (645,640,635), KN
  635 HWMX = FN(3)
  640 ZP = FN(2)
  645 CTMIN = FN(1)
      GO TO 5
C
C     PREVEC  CARD
C
  700 IF(KN-3) 850,710,705
  705 PREFOF = FN(4)
  710 POV(1) = FN(1)
      POV(2) = FN(2)
      POV(3) = FN(3)
      GO TO 5
C
C     ERROR ON CARD
C
  850 WRITE(NTOUT,1040)
      WRITE(NTOUT,1020) COL
      GO TO 5
  860 CALL ERROR(10)
      GO TO 5
  865 CALL ERROR (11)
      GO TO 5
C
C     END CARD
C
  900 IPFX(NF+1) = IP
C     WHICH RADIATION
      IF(IXN.EQ.1)  GO TO 920
C    NEUTRON, SET POLRA TO 1.0 FOR CORRECT LP FACTOR
      POLRA = 1.0
  920 IF(IDEX.EQ.0)  GO TO 980
      IF(ICELL.EQ.1)  GO TO 980

      WRITE(NTOUT,1045)
      CALL ERROR (2)
C
  980 RETURN
C
C     TERMINATE PROGRAM (FINISH CARD)
C
  990 WRITE(NTOUT,1030) COL
      STOP
C
C     LIST OF FORTRAN FORMATS
C
 1000 FORMAT (80A1)
 1020 FORMAT (' CARD IMAGE: ',80A1)
 1030 FORMAT (//3H***,80A1)
 1040 FORMAT (' ERROR ON INPUT CARD ')
 1045 FORMAT ('NO CELL CARD SUPPLIED, JOB TERMINATED')
C
      END
      SUBROUTINE OUTDAT
      character*4 mcent,itype,isymb
      integer*4 iext,ISPACE,ICENT,LTRAN,NSYM,ITRAN
      CHARACTER*1 COL,NL,ITIT,ICOMP
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL

      COMMON /IC/ IC(13)
      COMMON /PA/ ICURV,IHAIN,IHAOUT,IHW,IPAS,IWHA,JL,JU,IPRANA,
     $            CTMIN,HWMX,QJT,QINT,TSTART,TSTEP,
     $            ZP,HWAR(100),PASAR(100)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF
      COMMON IEXT,ISPACE,ICENT,LTRAN,zzzz1,NSYM,RL(3,4)
     $     ,RS(48,3,4),ITRAN(30),zzzz2(48,30),NC(13),DCP(6),zzzz3(3917),
     $     mcent,itype(80),isymb(48,30)
      CHARACTER*8 ILAUE,LCENT
      CHARACTER*4 IRAD1,IRAD2
      DIMENSION ILAUE(15),LCENT(2),IRAD1(2),IRAD2(2)
      DATA ILAUE/2H1-      ,3H2/M     ,3H2/M     ,3HMMM     ,3H4/M
     $      ,5H4/MMM   ,2HM3      ,3HM3M     ,8H3- (RHO),8H3-M(RHO)
     $      ,8H3- (HEX),4H3-M1    ,3H6/M     ,5H6/MMM   ,4H3-1M    /
      DATA LCENT/8HACENTRIC,7HCENTRIC /
      DATA IRAD1,IRAD2/4HX-RA,4HNEUT,4HY   ,4HRON /

      NSYST = ISYST
C
C     PRINT LISTING OF INPUT DATA
C
      IPAGE = IPAGE + 1
      WRITE (NTOUT,1000)  IPAGE
      WRITE (NTOUT,1005) (ITIT(I),I=1,48)
      IF(IDEX.EQ.0)  GO TO 65
      GO TO (41,42,43,44,45,46,47,48,50,56,57,58,60), ISYST
   41 WRITE (NTOUT,1021)
      GO TO 40
   42 WRITE (NTOUT,1022)
      GO TO 40
   43 WRITE (NTOUT,1023)
      GO TO 40
   44 WRITE (NTOUT,1024)
      GO TO 40
   45 WRITE (NTOUT,1025)
      GO TO 40
   46 WRITE (NTOUT,1026)
      GO TO 40
   47 WRITE (NTOUT,1027)
      GO TO 40
   48 WRITE (NTOUT,1028)
      GO TO 40
   50 WRITE (NTOUT,1030)
      GO TO 40
   56 WRITE (NTOUT,1036)
      GO TO 40
   57 WRITE (NTOUT,1037)
      GO TO 40
   58 WRITE (NTOUT,1038)
      GO TO 40
   60 WRITE (NTOUT,1040)
   40 IF(ISPACE.NE.0) WRITE(NTOUT,1075) ISPACE,LCENT(ICENT)
      WRITE(NTOUT,1060) ILAUE(LAUE),LAUE
   70 WRITE (NTOUT,1013) (CC(I),I=1,6),VOL
      WRITE (NTOUT,1014) (RCC(I),I=1,6),RVOL
      WRITE (NTOUT,1029) (RCP(I),I=1,6)
      DO 71 I=1,6
   71 DCP(I) = CC(I)
      IF (ISYST .GT. 12) GO TO 59
      IF (ISYST .LT. 11 .AND. ISYST .NE. 4) GO TO 59
      AR = SQRT((CC(1)**2)/3.0 + (CC(3)**2)/9.0)
      ALF = 2.0/RD * ASIN(3.0/(2.0*SQRT(3.0+(CC(3)/CC(1))**2)))
      WRITE (NTOUT,1039) AR,AR,AR,ALF,ALF,ALF
   59 CONTINUE
      WRITE (NTOUT,1015) (NC(I),I=1,13)
      IF (ISYST .LT. 8 .OR. ISYST .GT. 10) GO TO 52
C
C     TRANSFORM RHOMBOHEDRAL CELL TO HEXAGONAL CELL
C
      WRITE (NTOUT,1033)
      SIX=SIN(CC(4)/2.0*RD)
      CC(1)=2.0*CC(1)*SIX
      CC(3)=CC(1)*SQRT(9.0/(4.0*SIX**2) - 3.0)
      CC(2) = CC(1)
      CC(4) = 90.
      CC(4) = 90.
      CC(5) = 90.
      CC(6) = 120.
      CALL RCELL
      WRITE (NTOUT,1013) (CC(I),I=1,6),VOL
      WRITE (NTOUT,1014) (RCC(I),I=1,6),RVOL
      WRITE (NTOUT,1029) (RCP(I),I=1,6)
      ICS=IC(5)
      IF (ICS .EQ. 0) ICS=3
      DO 53 I=5,12
      IC(I)=3
   53 CONTINUE
      DO 54 I=2,4
      IC(I)=5
   54 CONTINUE
      IC(13)=5
      IC(6)=ICS
      IF (ISYST .EQ. 8 .OR. ISYST .EQ. 10) IC(1)=6
      IF (ISYST .EQ. 9) IC(1)=7
   52 CONTINUE
      ISYST = NSYST
      IF (ISYST .EQ. 4 .AND. IC(1) .NE. 9 .AND. IC(1) .NE. 0) ISYST=10
      IF (ISYST .EQ. 4 .AND. IC(5) .EQ. 1) ISYST=10
      IF (ISYST .EQ. 4 .AND. IC(6) .EQ. 1) ISYST=10
C
C     PRINT REMAINING PARAMETERS
C
   65 WRITE (NTOUT,1016) XLAMDA,POLRA,THMIN,THMAX
      WRITE(NTOUT,1018) IRAD1(IXN),IRAD2(IXN)
C----PRINT PREFERRED ORIENTATION VECTOR AND ITS MAGNITUDE
      POVM = RCP(1)*POV(1)*POV(1) + RCP(2)*POV(2)*POV(2)
     $      +RCP(3) * POV(3)*POV(3) + RCP(4)*POV(2)*POV(3)
     $      +RCP(5) * POV(1)*POV(3) + RCP(6)*POV(1)*POV(2)
      POVM = SQRT(POVM)
      WRITE(NTOUT,1017) (POV(I),I=1,3),POVM,PREFOF
      IF(IHW.NE.2)  GO TO 80
      R = ABS(RANGE)
      WRITE(NTOUT,1085) WDU,WDV,WDW,R
   80 IF(IPAS.NE.2)  GO TO 85
      WRITE(NTOUT,1130) CA1,CA2,CA3
   85 WRITE(NTOUT,1125) NF
      IF(ISPACE.EQ.0)  GO TO 110
      WRITE(NTOUT,1100) ISPACE
      WRITE(NTOUT,1120)(N,(ISYMB(N,I),I=1,30),N=1,NSYM)
      if(ltran.gt.1) then
      write(ntout,1105) lcent(icent),mcent
      else
      write(ntout,1110) lcent(icent)
      endif
c     WRITE(NTOUT,1105)  LCENT(ICENT)
c     IF(LTRAN.GT.1)  GO TO 100
c     WRITE(NTOUT,1110)
c     GO TO 110
c 100 WRITE(NTOUT,1115) MCENT
  110 IF(IHW.GT.0.AND.IPAS.GT.0)  GO TO 200
      WRITE(NTOUT,1135) CTMIN,ZP,HWMX
  200 RETURN
C
C     LIST OF FORTRAN FORMATS
C
 1000 FORMAT (' STEP SCAN PROFILE ANALYSIS AND INDICES GENERATION'
     $ ,39X,'PAGE',I4/1x,49(1H*)/)
 1005 FORMAT (1x,74A1,/)
 1013 FORMAT (' CELL CONSTANTS',11X,3F10.4,3X,3F10.4/
     $ ' CELL VOLUME',14X,F10.4)
 1014 FORMAT (' RECIPROCAL CELL CONSTANTS',3X,3F10.7,3F10.4,
     $/' REC. CELL VOLUME',10X,F15.10)
 1015 FORMAT (' EXTINCTION CODE = ',10X,13I3)
 1016 FORMAT (' WAVE-LENGTH     =',F9.5,4X,'POLARISATION RATIO =',
     $ F9.4,/' 2 THETA-MIN     =',F9.2,4X,'2 THETA-MAX',8X,'=',F9.2)
 1017 FORMAT (' PREFERRED ORIENTATION VECTOR ',3F5.0,5X,'MAGNITUDE',
     $F12.5,/' PREFERRED ORIENTATION FACTOR ',F15.5)
 1018 FORMAT (' RADIATION: ',2A4)
 1021 FORMAT (' CUBIC LATTICE')
 1022 FORMAT (' TETRAGONAL LATTICE')
 1023 FORMAT (' ORTHORHOMBIC LATTICE')
 1024 FORMAT (' HEXAGONAL LATTICE')
 1025 FORMAT (' MONOCLINIC LATTICE   (FIRST SETTING)')
 1026 FORMAT (' MONOCLINIC LATTICE   (SECOND SETTING)')
 1027 FORMAT (' TRICLINIC LATTICE')
 1028 FORMAT (' RHOMBOHEDRAL LATTICE   (OBVERSE)')
 1029 FORMAT (' RECIPROCAL CROSS PRODUCTS',1X,3F15.10,/26X,3F15.10)
 1030 FORMAT (' RHOMBOHEDRAL LATTICE   (REVERSE)')
 1033 FORMAT (' CORRESPONDING HEXAGONAL LATTICE')
 1036 FORMAT (' RHOMBOHEDRAL LATTICE WITH HEXAGONAL INDICES')
 1037 FORMAT (' HEXAGONAL LATTICE WITH OBVERSE RHOMBOHEDRAL INDICES')
 1038 FORMAT (' HEXAGONAL LATTICE WITH REVERSE RHOMBOHEDRAL INDICES')
 1039 FORMAT (' CORRESPONDING RH. LATTICE',/1X,6F10.4)
 1040 FORMAT (' MONOCLINIC LATTICE   (THIRD SETTING)')
 1060 FORMAT (' LAUE GROUP ',A8,'(NR.',I3,')')
 1075 FORMAT (' SPACE GROUP NR.',I5,2X,'(',A8,')')
 1085 FORMAT (' HALF WIDTH      = SQRT(',F8.6,' + ',
     $ F8.6,16H * TAN(THETA) + ,F8.6,18H * (TAN(THETA))**2, /
     $ ' PEAK RANGE      =',F6.1,14H * HALF WIDTH )
 1100 FORMAT (/' SYMMETRY INFORMATION FOR SPACE GROUP NR.',I5)
C1105 FORMAT (' THE SPACE GROUP IS ',A8,' AND ')
C1110 FORMAT ('+',32X,'PRIMITIVE')
C1115 FORMAT ('+',32X,A2,'CENTERED')
 1105 FORMAT (' THE SPACE GROUP IS ',A8,' AND ',A2,'CENTERED')
 1110 FORMAT (' THE SPACE GROUP IS ',A8,' AND PRIMITIVE')
 1120 FORMAT (' CODED SYMMETRY OPERATIONS'/
     $ '    NR.',5X,'TRANSFORMED X   TRANSFORMED Y   TRANSFORMED Z'//
     $ (2X,I5,1X,3(6X,10A1)))
C
 1125 FORMAT (' NUMBER OF FORM FACTORS READ',I3)
 1130 FORMAT (' PEAK ASYMMETRY  =',F8.6,' + ',F8.6,'/1x,TAN(THETA) + ',
     $  F8.6,16H /(TAN(THETA)**2 )
 1135 FORMAT (' PROFAN PARAMETERS: ',F8.0,2F8.2)
      END

      SUBROUTINE HKL
C
C     SUBROUTINE TO SET UP THE MILLER-INDECES OF POWDER-PATTERN
C
      CHARACTER*1 ITIT,ICOMP
      character*4 mcent,itype,isymb
      integer*4 index
      COMMON /IC/ IC(13)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000),QS(3000),mcent,itype(80),isymb(1440)
C
C     DEFINE FACTORS FOR ENCODING OF H K L
C
      MAXHKL = 49
      ISHIFT = MAXHKL + 1
      KFAC = 2*ISHIFT
      JFAC = KFAC * KFAC
      LFAC = 1
C
      NDIM=3000
      N = 0
      MH = 0
      MK = 0
      ML = 0
      AS=RCP(1)
      BS=RCP(2)
      CS=RCP(3)
      ALS=RCP(4)
      BES=RCP(5)
      GAS=RCP(6)
      QMAX =  (2.0/XLAMDA*SIN(THMAX/2.0*RD))
      QMAX = QMAX * QMAX
      GO TO (91,92,93,92,95,96,97,98,99,64,98,99,94), ISYST
C
C     CUBIC SYSTEM
C
C     REARANGE INDECES IN DECENDING ORDER
   91 MH = SQRT(QMAX/AS + .1)
      MK = MH
      ML = MH
      DO 11 JJ=1,MAXHKL
      J=JJ-1
      J2=J**2
      IDJ=J+ISHIFT
      DO 12 KK=JJ,MAXHKL
      K=KK-1
      NTERMA=J2+K**2
      IDJK = IDJ + KFAC*(K+ISHIFT)
C
C     CHECK FOR ADDITIONAL INDECES FOR LAUE GROUP M3
C
      IADDL = 0
      IF(LAUE.NE.7)  GO TO 17
      IF(K.EQ.J)  GO TO 17
      IF(K.EQ.0)  GO TO 17
      IADDL = 1
C
   17 DO 13 LL=KK,MAXHKL
      L=LL-1
      Q=(NTERMA + L**2) * AS
      IF (Q .LE. QMAX) GO TO 15
      IF ((KK .EQ. JJ) .AND. (LL .EQ. KK)) GO TO 90
      IF (KK .EQ. LL) GO TO 11
      GO TO 12
   15 IF (NEX .EQ. 0) GO TO 16
      CALL EXT (L,K,J,IEX)
      IF (IEX .EQ. 1) GO TO 13
   16 N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N) = Q
      INDEX(N)=IDJK + JFAC*(L+ISHIFT)
C
C     GENERATE ADDITIONAL INDECES FOR LAUE GROUP M3
C
      IF(IADDL.EQ.0) GO TO 13
      IF(L.EQ.K)  GO TO 13
      N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      INDEX(N) = JFAC*(K+ISHIFT) + KFAC*(L+ISHIFT) + J + ISHIFT
      QS(N) = Q
   13 CONTINUE
   12 CONTINUE
   11 CONTINUE
      GO TO 100
C
C     TETRAGONAL AND HEXAGONAL SYSTEM WITH ONLY SERIAL EXTINCTIONS
C
C     REARANGE FIRST TWO INDICES IN DECENDING ORDER
   92 MIX=0
      MH = SQRT(QMAX/AS + .1)
      MK = MH
      ML = SQRT(QMAX/CS + .1)
      DO 21 JJ=1,MAXHKL
      J=JJ-1
      J2=J**2
      IDJ= KFAC*(J+ISHIFT)
      DO 22 KK=JJ,MAXHKL
      K=KK-1
      IDJK=IDJ + JFAC*(K+ISHIFT)
      IF (ISYST .EQ. 2) GO TO 24
      MIX=J*K
   24 TERMA = (J2 + MIX + K**2) * AS
C
C     CHECK FOR ADDITIONAL INDECES FOR LAUE GROUP 4/M OR 6/M
C     AND 3- , 3-M1 OR 3-1M
C
      IADDL = 0
      IF(LAUE.EQ.6)  GO TO 27
      IF(LAUE.EQ.14)  GO TO 27
      IF(LAUE.EQ.5)  GO TO 28
      IF(LAUE.NE.13)  GO TO 29
   28 IF(J.EQ.0 .OR. K.EQ.0)  GO TO 27
      IF(J.EQ.K) GO TO 27
      IADDL = 1
      GO TO 27
C
C     LAUE GROUPS NR 15, 12 AND 11
C
   29 IF(LAUE.EQ.11)  GO TO 124
      IF(LAUE.EQ.12)  GO TO 120
      IF(LAUE.EQ.15)  GO TO 122
      CALL ERROR (8)
      LAUE = 6
      IF(ISYST.NE.2) LAUE = 14
      GO TO 27
  120 IF(J.EQ.K)  GO TO 27
      IADDL = 2
      GO TO 27
  122 IF(J.EQ.0.OR.K.EQ.0)  GO TO 27
      IADDL = 2
      GO TO 27
  124 IADDL = 3
   27 DO 23 LL=1,MAXHKL
      L=LL-1
      Q = TERMA + L**2 * CS
      IF (Q .LE. QMAX) GO TO 25
      IF (KK .EQ. JJ .AND. LL .EQ. 1) GO TO 90
      IF (LL .EQ. 1) GO TO 21
      GO TO 22
   25 IF (NEX .EQ. 0) GO TO 26
      CALL EXT (K,J,L,IEX)
      IF (IEX .EQ. 1) GO TO 23
   26 N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N) = Q
      INDEX(N) = IDJK + L+ISHIFT
C
C     GENERATE ADDITIONAL INDECES FOR LAUE GROUP 4/M OR 6/M
C
      IF(IADDL-1) 23,125,126
  125 N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      QS(N) = Q
      IF(LAUE.EQ.13)  GO TO 123
      INDEX(N) = JFAC*(J+ISHIFT) + KFAC*(K+ISHIFT) + L + ISHIFT
      GO TO 23
  123 INDEX(N) = JFAC*(K+ISHIFT) + KFAC*(-J-K+ISHIFT) + L + ISHIFT
      GO TO 23
  126 IF(IADDL.EQ.3)  GO TO 128
      IF(L.EQ.0)  GO TO 23
      N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      QS(N) = Q
      INDEX(N) = INDEX(N-1) - L - L
      GO TO 23
  128 IF(L.EQ.0)  GO TO 129
      IF(K.EQ.0)  GO TO 23
      N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      QS(N) = Q
      INDEX(N) = INDEX(N-1) - L - L
  129 IF(J.EQ.0)  GO TO 23
      IF(J.EQ.K)  GO TO 23
      N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      QS(N) = Q
      INDEX(N) = JFAC*(K+ISHIFT) + KFAC*(-J-K+ISHIFT) + L + ISHIFT
      IF(L.EQ.0)  GO TO 23
      N = N + 1
      IF(N.GT.NDIM)  GO TO 101
      QS(N) = Q
      INDEX(N) = INDEX(N-1) -L - L
   23 CONTINUE
   22 CONTINUE
   21 CONTINUE
      GO TO 100
C
C     ORTHORHOMBIC SYSTEM
C
   93 MH = SQRT(QMAX/AS + .1)
      MK = SQRT(QMAX/BS + .1)
      ML = SQRT(QMAX/CS + .1)
      DO 31 JJ=1,MAXHKL
      J=JJ-1
      IDJ = JFAC*(J+ISHIFT)
      TERMA = J**2 * AS
      DO 32 KK=1,MAXHKL
      K=KK-1
      IDJK = IDJ + KFAC*(K+ISHIFT)
      TERMB = TERMA + K**2*BS
      DO 33 LL=1,MAXHKL
      L=LL-1
      Q = TERMB + L**2 * CS
      IF (Q .LE. QMAX) GO TO 35
      IF (KK .EQ. 1 .AND. LL .EQ. 1) GO TO 90
      IF (LL .EQ. 1) GO TO 31
      GO TO 32
   35 IF (NEX .EQ. 0) GO TO 36
      CALL EXT(J,K,L,IEX)
      IF (IEX .EQ. 1) GO TO 33
   36 N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N) = Q
      INDEX(N) = IDJK + L+ISHIFT
   33 CONTINUE
   32 CONTINUE
   31 CONTINUE
      GO TO 100
C
C     MONOCLINIC SYSTEM   (FIRST SETTING)
C
   95 NTEST=0
      QTEST=0.0
      MONO=1
      IF (GAS .GE. 0.0) GO TO 44
      MONO=-1
      GAS=-GAS
   44 MMM=3
   81 DO 41 JJ=1,MAXHKL
      J=JJ-1
      IDJ=JFAC*(J+ISHIFT)
      TERMA = J**2 * AS
      DO 47 II=MMM,3,2
      I=II-2
      III=(II+1)/2
      IF (JJ .EQ. 1) III=1
      DO 42 KK=III,MAXHKL
      K=(KK-1) * I
      IDJK= IDJ+KFAC*(MONO*K+ISHIFT)
      TERMB = TERMA + K**2 * BS + J*K * GAS
      DO 43 LL=1,MAXHKL
      L=LL-1
      Q = TERMB + L**2*CS
      IF (Q .LE. QMAX) GO TO 45
      IF (NTEST .EQ. 2) GO TO 48
      IF (KK .EQ. III .AND. LL .EQ. 1) GO TO 48
      GO TO 49
   48 IF (Q .LE. QTEST) NTEST=1
      IF (NTEST .EQ. 2) GO TO 40
      QTEST=Q
      NTEST=2
      GO TO 42
   40 IF (II .EQ. 1) GO TO 90
      GO TO 47
   49 IF (LL .EQ. 1) GO TO 47
      GO TO 42
   45 NTEST=0
      IF (NEX .EQ. 0) GO TO 46
      CALL EXT(J,K,L,IEX)
      IF (IEX .EQ. 1) GO TO 43
   46 N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N) = Q
      INDEX(N)=IDJK+LFAC*(L+ISHIFT)
      IF(MH.LT.J)  MH = J
      KA = IABS(K)
      IF(MK.LT.KA) MK = KA
      IF(ML.LT.L) ML = L
   43 CONTINUE
   42 CONTINUE
   47 CONTINUE
      MMM=1
   41 CONTINUE
      GO TO 100
C
C     MONOCLINIC SYSTEM   (SECOND SETTING)
C
   96 GAS=BES
      BES=0.0
      A=CS
      CS=BS
      BS=A
      LFAC = 2*ISHIFT
      JFAC = LFAC * LFAC
      KFAC = 1
      IF (IC(1) .EQ. 3) IC(1)=2
      IC(2) = IC(3)
      IC(3) = 5
      IF (IC(12) .NE. 1) GO TO 95
      IC(13)=1
      IC(12)=3
      GO TO 95
C
C     MONOCLINIC SYSTEM   (THIRD SETTING)
C
   94 GAS=ALS
      ALS=0.0
      A=AS
      AS=BS
      BS=CS
      CS=A
      KFAC=1
      JFAC = 2*ISHIFT
      LFAC = JFAC * JFAC
      IF (IC(1) .EQ. 1) IC(1)=2
      IC(2)=IC(4)
      IC(4)=5
      IF (IC(11) .NE. 1) GO TO 95
      IC(13)=1
      IC(11)=3
      GO TO 95
C
C     TRICLINIC SYSTEM
C
   97 NNTEST=0
      KKTEST=0
      JTEST=0
      QTEST = 0.0
      QHOLD=0.0
      LLL=3
      DO 51 JJ=1,MAXHKL
      KTEST=0
      J=JJ-1
      IDJ = JFAC*(J+ISHIFT)
      TERMA = J**2 * AS
      DO 57 II=LLL,3,2
      I=II-2
      III=(II+1)/2
      IF (JJ .EQ. 1) III=1
      DO 52 KK=III,MAXHKL
      NTEST=0
      K=(KK-1) * I
      IDJK = IDJ + KFAC*(K+ISHIFT)
      TERMB = TERMA + K**2*BS + J*K*GAS
      DO 73 MM=1,3,2
      M2=MM
      IF (JJ .EQ. 1 .AND. KK .EQ. 1) M2=3
      M=M2-2
      MMM=(M2+1)/2
      DO 53 LL=MMM,MAXHKL
      L=(LL-1) * M
      Q = TERMB + L**2*CS + K*L*ALS + J*L*BES
      IF (Q .LE. QMAX) GO TO 55
      IF (LL .EQ. 1 .OR. NTEST .EQ. 2) GO TO 54
      GO TO 58
   54 IF (KK .EQ. 1) JTEST=1
      IF (Q .LE. QTEST) NTEST=1
      IF (NTEST .EQ. 2) GO TO 59
      QTEST=Q
      NTEST=2
      GO TO 53
   59 NNTEST=NNTEST+1
      IF (NNTEST .LT. 2) GO TO 58
      NNTEST=0
      IF (JTEST .EQ. 1) GO TO 71
      GO TO 57
   71 IF (QTEST .LE. QHOLD) KTEST=1
      IF (KTEST .EQ. 2) GO TO 72
      QHOLD=QTEST
      KTEST=2
      GO TO 52
   72 KKTEST=KKTEST+1
      IF (KKTEST .EQ. 2) GO TO 90
      GO TO 57
   55 NTEST=0
      KTEST=0
      NNTEST=0
      KKTEST=0
      JTEST=0
      IF (NEX .EQ. 0) GO TO 56
      CALL EXT(J,K,L,IEX)
      IF (IEX .EQ. 1) GO TO 53
   56 N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N)=Q
      INDEX(N) = IDJK + L+ISHIFT
      IF(MH.LT.J) MH = J
      KA = IABS(K)
      IF(MK.LT.KA) MK = KA
      LA = IABS(L)
      IF(ML.LT.LA) ML = LA
   53 CONTINUE
   58 CONTINUE
      IF (M2 .GE. 3) GO TO 52
   73 CONTINUE
   52 CONTINUE
   57 CONTINUE
      LLL=1
   51 CONTINUE
      GO TO 100
C
C     RHOMBOHEDRAL SYSTEM BUT HEXAGONAL CALCULATED
C     HEXAGONAL SYSTEM WITH OTHER THAN SERIAL EXTINCTIONS
C
C     REARANGE FIRST TWO INDICES IN DECENDING ORDER
   98 S11=2.0/3.0
      S13=1.0/3.0
      S12=S13
      S21=-S13
      S22=S13
      S23=S13
      S31=-S13
      S32=-S11
      S33=S13
      GO TO 64
   99 S11=1.0/3.0
      S12=-S11
      S13=S11
      S21=S11
      S22=2.0/3.0
      S23=S11
      S31=-S22
      S32=-S11
      S33=S11
   64 DO 61 JJ=1,MAXHKL
      J=JJ-1
      J2=J**2
      DO 62 KK=JJ,MAXHKL
      K=KK-1
      TERMA = (J2 + J*K + K**2) * AS
      DO 63 LL=1,MAXHKL
      L=LL-1
      Q = TERMA + L**2 * CS
      IF (Q .LE. QMAX) GO TO 65
      IF (KK .EQ. JJ .AND. LL .EQ. 1) GO TO 90
      IF (LL .EQ. 1) GO TO 61
      GO TO 62
   65 L=-L
      DO 67 M1=1,2
      L=-L
      CALL EXT (K,J,L,IEX)
      IF (IEX .EQ. 1) GO TO 67
      IF (J .NE. 0 .OR. K .EQ. 0) GO TO 68
      CALL EXT (-K,K,L,IEX)
      IF (IEX .EQ. 1) GO TO 67
   68 CONTINUE
      N=N+1
      IF (N .GT. NDIM) GO TO 101
      QS(N)=Q
      IF (ISYST .NE. 10) GO TO 60
      JR=K
      KR=J
      LR=L
      GO TO 69
   60 CONTINUE
C     TRANSFORMATION TO RHOMBOHEDRAL INDICES AND ELIMINATION OF ROUNDING
C     ERRORS
      S  = S11*K+S12*J +S13*L
      JR = S+SIGN(0.2,S)
      S  = S21*K+S22*J +S23*L
      KR = S+SIGN(0.2,S)
      S  = S31*K+S32*J +S33*L
      LR = S+SIGN(0.2,S)
  200 JJR = IABS(JR)
      KKR = IABS(KR)
      LLR = IABS(LR)
C----REARANGE INDICES
      IF(JJR-KKR) 205,210,210
  205 JS = JR
      JR = KR
      KR = LR
      LR = JS
      GO TO 200
  210 IF(JJR-LLR) 205,220,220
  220 IF(JR) 225,230,230
  225 JR = - JR
      KR = - KR
      LR = -LR
  230 IF(MH.LT.JJR)  MH = JJR
      IF(MK.LT.KKR) MK = KKR
      IF(ML.LT.LLR) MK = LLR
   69 INDEX(N) = JFAC*(JR+ISHIFT)+KFAC*(KR+ISHIFT)+(LR+ISHIFT)
      GO TO 63
   67 CONTINUE
   63 CONTINUE
   62 CONTINUE
   61 CONTINUE
      GO TO 100
C
C     PRINT ERROR MESSAGES
C
  101 CALL ERROR(8)
      N=NDIM
      GO TO 90
  100 CALL ERROR(2)
   90 NMAX=N
C----IF IT IS MONOCLINIC 2ND OR 3RD SETTING, GET CORRECT MAN HKL VALUES
      IF(ISYST.EQ.13)  GO TO 310
      IF(ISYST.NE.6)   GO TO 999
C---- 2ND SETTING
      MML = MK
      MK = ML
      ML = MML
      GO TO 999
C---- 3RD SETTING
  310 MML = MK
      MH = ML
      MK = MH
      ML = MML
  999 RETURN
      END
      SUBROUTINE CODE
C
C     SUBROUTINE TO CHECK AND COMPLETE EXTINCTION CODE
C
      character*4 mcent,itype,isymb
      integer*4 index
      CHARACTER*1 ITIT,ICOMP
      COMMON /IC/ IC(13)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000), QS(3000),mcent,itype(80),isymb(1440)
      NEX = 0
      DO 11 I=1,13
      IF (IC(I) .NE. 0) GO TO 12
   11 CONTINUE
      IF (ISYST .EQ. 11 .OR. ISYST .EQ. 12) GO TO 12
      GO TO 10
C     C
C     CHANGE CODE IF THERE ARE NO CONDITIONS
C
   12 IF (IC(1) .LE. 0 .OR. IC(1) .GT. 9) IC(1)=9
      DO 13 I=2,4
      IF (IC(I) .LE. 0 .OR. IC(I) .GT. 5) IC(I)=5
   13 CONTINUE
      DO 14 I=5,12
      IF (IC(I) .LE. 0 .OR. IC(I) .GT. 3) IC(I)=3
   14 CONTINUE
      IF (IC(13) .LE. 0 .OR. IC(13) .GT. 5) IC(13)=5
C
C     CHECK ALL CRYSTAL SYSTEMS
C
      GO TO (21,22,23,24,25,26,30,28,28,28,24,24,27), ISYST
C
C     CUBIC SYSTEM
C
   21 DO 31 I=6,10
      IC(I) = IC(5)
   31 CONTINUE
      DO 32 I=3,4
      IC(I) = IC(2)
      IC(I+9) = IC(11)
   32 CONTINUE
      IF (IC(13) .EQ. 2) IC(13)=3
      IF (IC(13) .EQ. 3) IC(13)=5
      IF (IC(1) .LT. 4) GO TO 30
      IF (IC(1) .GT. 5 .AND. IC(1) .LT. 9) GO TO 30
      IF (IC(13) .EQ. 2 .OR. IC(13) .EQ. 4) GO TO 30
      GO TO 20
C
C     TETRAGONAL SYSTEM
C
   22 IC(6)=IC(5)
      IC(3)=IC(4)
      IC(12)=IC(11)
      IF (IC(1) .NE. 5 .AND. IC(1) .NE. 9) GO TO 30
      IF (IC(2) .EQ. 4) GO TO 30
      DO 37 I=7,10
      IF (IC(I) .LT. 3) GO TO 30
   37 CONTINUE
      IF (IC(11) .EQ. 2) GO TO 30
      IF (IC(12) .EQ. 2) GO TO 30
      IF (IC(13) .EQ. 2 .OR. IC(13) .EQ. 4) GO TO 30
      GO TO 20
C
C     ORTHORHOMBIC SYSTEM
C
   23 IF (IC(1) .LT. 3 .OR. IC(1) .GT. 5 .AND. IC(1) .LT. 9) GO TO 30
      DO 38 I=5,10
      IF (IC(I) .LT. 3) GO TO 30
   38 CONTINUE
      IF (IC(11) .EQ. 2) GO TO 30
      IF (IC(12) .EQ. 2) GO TO 30
      IF (IC(13) .GT. 1 .AND. IC(13) .LT. 5) GO TO 30
      GO TO 20
C
C     HEXAGONAL SYSTEM
C
   24 IF (IC(1) .LT. 6) GO TO 30
      DO 33 I=2,4
      IF (IC(I) .NE. 5) GO TO 30
   33 CONTINUE
      DO 34 I=7,12
      IF (IC(I) .NE. 3) GO TO 30
   34 CONTINUE
      IF (ISYST .EQ. 11) IC(1)=6
      IF (ISYST .EQ. 12) IC(1)=7
      IF (IC(13) .EQ. 3) GO TO 30
      IF (IC(5) .EQ. 2) GO TO 30
      IF (IC(6) .EQ. 2) GO TO 30
      IF (ISYST .LE. 4) GO TO 20
      GO TO 20
C
C     MONOCLINIC SYSTEM   (FIRST SETTING)
C
   25 IF (IC(3) .LT. 5 .OR. IC(4) .LT. 5) GO TO 30
      IF (IC(2) .EQ. 4) GO TO 30
      IF (IC(1) .NE. 2 .AND. IC(1) .NE. 9) GO TO 30
      DO 39 I=5,12
      IF (IC(I) .LT. 3) GO TO 30
   39 CONTINUE
      IF (IC(13) .GT. 1 .AND. IC(13) .LT. 5) GO TO 30
      GO TO 20
C
C     MONOCLINIC SYSTEM   (SECOND SETTING)
C
   26 IF (IC( 4) .LT. 5 .OR. IC(2) .LT. 5) GO TO 30
      IF (IC(3) .EQ. 4) GO TO 30
      IF (IC(1) .NE. 3 .AND. IC(1) .NE. 9) GO TO 30
      DO 40 I=5,11
      IF (IC(I) .LT. 3) GO TO 30
   40 CONTINUE
      IF (IC(12) .EQ. 2) GO TO 30
      IF (IC(13) .LT. 5) GO TO 30
      GO TO 20
C
C     MONOCLINIC SYSTEM   (THIRD SETTING)
C
   27 IF (IC(2) .NE. 5 .OR. IC(3) .NE. 5) GO TO 30
      IF (IC(4) .EQ. 4) GO TO 30
      IF (IC(1) .NE. 1 .AND. IC(1) .NE. 9) GO TO 30
      DO 41 I=5,10
      IF (IC(I) .LT. 3) GO TO 30
   41 CONTINUE
      IF (IC(11) .EQ. 2) GO TO 30
      IF (IC(12) .LT. 3) GO TO 30
      IF (IC(13) .LT. 5) GO TO 30
      GO TO 20
C
C     RHOMBOHEDRAL LATTICE
C
   28 IF (IC(1) .LT. 9) GO TO 30
      DO 35 I=2,4
      IF (IC(I) .LT. 5) GO TO 30
   35 CONTINUE
      DO 36 I=6,12
      IF (IC(I) .LT. 3) GO TO 30
   36 CONTINUE
      IF (IC(13) .LT. 5) GO TO 30
      IF (IC(5) .EQ. 2) GO TO 30
      GO TO 20
C
C     PRINT ERROR MESSAGE
C
   30 CALL ERROR(1)
C
   20 NEX = 1
   10 CONTINUE
      RETURN
      END
      SUBROUTINE WAVLEN (NTHET)
C
C     SUBROUTINE TO DETERMINE CRYSTAL SYSTEM AND WAVE-LENGTH
C
      character*4 mcent,itype,isymb
      integer*4 index
      CHARACTER*1 COL,NL,NALPHA,LAMDA,ITIT,ICOMP
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000), QS(3000),mcent,itype(80),isymb(1440)
C
C     DETERMINE WAVE-LENGTH
C
      NALPHA = NL(1,3)
      LAMDA = NL(1,1)
      IF (LAMDA .NE. 'C') GO TO 11
      AL1=1.540598
      AL2=1.54434
      GO TO 10
   11 IF (LAMDA .NE. 'F') GO TO 12
      AL1=1.93597
      AL2=1.93991
      GO TO 10
   12 IF (LAMDA .NE. 'M') GO TO 13
      AL1=0.70926
      AL2=0.71354
      GO TO 10
   13 IF(LAMDA.EQ.'E' .AND. KN .GE. 1)  GO TO 90
      GO TO 20
   10 XLAMDA = AL1
      IF(NALPHA .EQ. '-') XLAMDA=(2.0*AL1 + AL2) / 3.0
      GO TO 100
   20 IF(LAMDA.EQ.'N'.AND.NL(1,2).EQ.'E') GO TO 22
      GO TO 95
   22 IXN = 2
   90 XLAMDA = FN(1)
      NTHET = 2
      GO TO 100
   95 CALL ERROR(3)
  100 RETURN
      END

      SUBROUTINE CELL


C
C     SUBROUTINE TO CHECK CELL-CONSTANTS AND COMPUTE RECIPROCAL
C     CROSS PRODUCTS
C
      character*4 mcent,itype,isymb
      integer*4 index
      CHARACTER*1 COL,LN,ITIT,ICOMP
      COMMON /FR/ COL(80),LN(15,6),FN(20),NCHAR,KN,KL
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000),QS(3000) ,mcent,itype(80),isymb(1440)
C
C     CHECK AND COMPLETE CELL CONSTANTS
C
      IF(LN(1,1).EQ.'C')  GO TO 21
      IF(LN(1,1).EQ.'O')  GO TO 23
      IF(LN(1,1).EQ.'M')  GO TO 120
      IF(LN(1,1).EQ.'H')  GO TO 140
      IF(LN(1,1).EQ.'R')  GO TO 180
      IF(LN(1,1).EQ.'T'.AND.LN(1,3).EQ.'T')  GO TO 22
      IF(LN(1,1).EQ.'T'.AND.LN(1,3).EQ.'I')  GO TO 29
      GO TO 10
C
  120 IF(LN(1,4).EQ.'1')  GO TO 25
      IF(LN(1,4).EQ.'2')  GO TO 26
      IF(LN(1,4).EQ.'3')  GO TO 27
      GO TO 10
C
  140 IF(LN(1,3).EQ.'X')  GO TO 141
      IF(LN(1,3).EQ.'O')  GO TO 142
      IF(LN(1,3).EQ.'R')  GO TO 143
      GO TO 10
C
  141 ISYST = 4
      LAU = 14
      GO TO 24
  142 ISYST = 11
      LAU = 10
      GO TO 24
  143 ISYST = 12
      LAU = 10
      GO TO 24
C
  180 IF(LN(1,2).EQ.'O')  GO TO 181
      IF(LN(1,2).EQ.'R')  GO TO 182
      IF(LN(1,2).EQ.'H')  GO TO 183
      GO TO 10
C
  181 ISYST = 8
      LAU = 10
      GO TO 28
  182 ISYST = 9
      LAU = 10
      GO TO 28
  183 ISYST =10
      LAU = 12
      GO TO 24
C
C     CUBIC SYSTEM
   21 IF(KN.NE.1)  GO TO 10
      ISYST = 1
      LAU = 8
      DO 31 I = 1,3
      CC(I) = FN(1)
   31 CONTINUE
   32 DO 33 I=4,6
      CC(I) = 90.0
   33 CONTINUE
      GO TO 20
C     TETRAGONAL SYSTEM
   22 IF(KN.NE.2)  GO TO 10
      CC(1) = FN(1)
      CC(3) = FN(2)
      CC(2) = CC(1)
      ISYST = 2
      LAU = 6
      GO TO 32
C     ORTHORHOMBIC SYSTEM
   23 IF(KN.NE.3)  GO TO 10
      DO 34 I=1,3
   34 CC(I) = FN(I)
      ISYST = 3
      LAU = 4
      GO TO 32
C     HEXAGONAL SYSTEM
C
C
C
   24 IF(KN.NE.2)  GO TO 10
      CC(1) = FN(1)
      CC(3) = FN(2)
      CC(2) = CC(1)
      DO 35 I=4,5
      CC(I) = 90.0
   35 CONTINUE
      CC(6) = 120.0
      GO TO 20
C     MONOCLINIC SYSTEM   (FIRST SETTING)
   25 IF(KN.NE.4)  GO TO 10
      CC(6) = FN(4)
      ISYST = 5
      LAU = 3
      DO 36 I=4,5
      CC(I) = 90.0
   36 CONTINUE
  136 DO 137 I=1,3
  137 CC(I) = FN(I)
      GO TO 20
C     MONOCLINIC SYSTEM   (SECOND SETTING)
   26 CC(4) = 90.0
      CC(6) = 90.0
      IF(KN.NE.4)  GO TO 10
      CC(5) = FN(4)
      ISYST = 6
      LAU = 2
      GO TO 136
C     MONOCLINIC SYSTEM   (THIRD SETTING)
   27 CC(5)=90.0
      CC(6)=90.0
      IF(KN.NE.4)  GO TO 10
      CC(4) = FN(4)
      ISYST = 13
      LAU = 16
      GO TO 136
C     RHOMBOHEDRAL SYSTEM
   28 IF(KN.NE.2)  GO TO 10
      DO 37 I=1,3
      CC(I) = FN(1)
      CC(I+3) = FN(2)
   37 CONTINUE
      GO TO 20
C     TRICLINIC SYSTEM
   29 IF(KN.NE.6)  GO TO 10
      DO 39 I=1,6
   39 CC(I) = FN(I)
      ISYST = 7
      LAU = 1
C
C     COMPUTE RECIPROCAL CROSS PRODUCTS
C
      ENTRY RCELL
   20 DO 38 I=4,6
      IF (CC(I) .LE. 0.0) GO TO 10
      IF (CC(I-3) .LE. 0.0) GO TO 10
      CC(I) = CC(I) * RD
   38 CONTINUE
      SINAL=SIN(CC(4))
      SINBE=SIN(CC(5))
      SINGA=SIN(CC(6))
      COSAL=COS(CC(4))
      COSBE=COS(CC(5))
      COSGA=COS(CC(6))
      VOL = CC(1)*CC(2)*CC(3) * SQRT(1.0-COSAL**2-COSBE**2-COSGA**2+
     Z   2.0*COSAL*COSBE*COSGA)
      RVOL = 1.0/VOL
      RCC(1)=CC(2)*CC(3)*SINAL*RVOL
      RCC(2)=CC(3)*CC(1)*SINBE*RVOL
      RCC(3)=CC(1)*CC(2)*SINGA*RVOL
      RCC(4)=(COSBE*COSGA-COSAL) / (SINBE*SINGA)
      RCC(5)=(COSGA*COSAL-COSBE) / (SINGA*SINAL)
      RCC(6)=(COSAL*COSBE-COSGA) / (SINAL*SINBE)
      RCP(1)=RCC(1)**2
      RCP(2)=RCC(2)**2
      RCP(3)=RCC(3)**2
      RCP(4)=2.0*RCC(2)*RCC(3)*RCC(4)
      RCP(5)=2.0*RCC(3)*RCC(1)*RCC(5)
      RCP(6)=2.0*RCC(1)*RCC(2)*RCC(6)
      DO 42 I=4,6
      RCC(I)=ACOS(RCC(I)) / RD
      CC(I)=CC(I)/RD
   42 CONTINUE
      GO TO 41
C
C     PRINT ERROR MESSAGE
C
   10 CALL ERROR(5)

   41 IF(LAUE.EQ.0.) LAUE = LAU
      RETURN
      END
      SUBROUTINE OUTHKL
C
C     SUBROUTINE TO SORT IN INCREASING 2THETA-VALUES
C     PUNCH HKL CARDS FOR DATRDN PROGRAM
C
      character*4 mcent,itype,isymb
      integer*4 index
      CHARACTER*1 ITIT,ICOMP
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF
      COMMON INDEX(3000),QS(3000),mcent,itype(80),isymb(1440)
C
C     SET ENCODING FACTORS FOR HKL
C
      ISHIFT = MAXHKL + 1
      KFAC = ISHIFT + ISHIFT
      JFAC = KFAC * KFAC
C
      MULT = 0
      LMAX=60
      JCODE = 1
      JED = 0
      JWD = 0
      LINE= 6
      NREFL = 0
      IF (NMAX .LE. 1) GO TO 10
      PREFO = 1.
      R2D=2.0/RD
      IF(LISTH.EQ.0) GO TO 5
      IPAGE = IPAGE + 1
      WRITE(NTOUT,600) ITIT,RDATE,IPAGE
      WRITE(NTOUT,601)
C
C     SORT WITH DECREASING Q-VALUES
C
    5 NMAX1 = NMAX - 1
      DO 20 M=1,NMAX1
      M1=M+1
      DO 15 N=M1,NMAX
      IF (QS(M) .LE. QS(N)) GO TO 15
      A=QS(M)
      QS(M)=QS(N)
      QS(N)=A
      I=INDEX(M)
      INDEX(M)=INDEX(N)
      INDEX(N)=I
   15 CONTINUE
C
C     GET RID OF REFLECTION 0 0 0
C
   16 IF(QS(M).LT.1.E-10)  GO TO 20
C
      IF (LINE .LT. LMAX) GO TO 13
      IPAGE = IPAGE + 1
      WRITE(NTOUT,600) ITIT,RDATE,IPAGE
      WRITE (NTOUT,601)
      LINE= 6
C
C     DECODE INDICES AND PREPARE DATA FOR HKL CARDS
C
   13 J=INDEX(M)/JFAC - ISHIFT
      K= MOD(INDEX(M),JFAC)/KFAC - ISHIFT
      L=MOD(INDEX(M),KFAC) - ISHIFT
      IF(LAUE.NE.0)   MULT = FMULT(J,K,L)
      D=SQRT(1.0/QS(M))
      SINTL=0.5/D
      SINTH=SINTL*XLAMDA
      ATHET1 = ASIN(SINTH)
      ATHET2 = ATHET1 + ATHET1
      THETA2 = R2D * ATHET1
      CALL TTINTPL(THETA2,0,WD)
      WD1 = WD + WD
      PRANGE = WD1 * RANGE
      CALL TTINTPL(THETA2,100,PASYM)
      RXLP = 1./XLPFAC(ATHET2)
C----CALL USER SUBROUTINE TO DETERMINE REFLECTION CODES JCODE AND JWD
C     CALL REFCOD (J,K,L,THETA,JCODE,JWD)
      CALL REFCOD (JCODE,JWD)
      IF(LCRD.EQ.0)  GO TO 17
   40 WRITE(NTCRD,610)J,K,L,JED,JCODE,THETA2,SINTL,RXLP,WD,PASYM,PREFO
     $,JWD
   17 IF(LISTH.EQ.0)  GO TO 18
      WRITE (NTOUT,602) J, K, L,MULT, THETA2,D,SINTL,WD,PASYM,PRANGE
     $ ,JCODE,JWD
      LINE = LINE + 1
C
C     SAVE 2 THETA AND ENCODE MULTIPLICITY
C
   18 QS(M) = THETA2
      INDEX(M) = INDEX(M)* KFAC + MULT
      NREFL = NREFL + 1
   20 CONTINUE
C
   10 WRITE(NTOUT,605) NREFL
      NMAX = NREFL
      WRITE(NTOUT,615) MH,MK,ML
      IF(LCRD.EQ.1) WRITE(NTCRD,620)
      RETURN
  600 FORMAT (' SPRING',6X,74A1,'  DATE: ',A9,7X,'PAGE',I4//)
  601 FORMAT (3X, 1HH,2X, 1HK,2X, 1HL,2X,4HMULT,4X, 7H2 THETA, 5X,
     Z  7HD-VALUE, 6X, 6HSINT/L, 4X, 9H WIDTH/2 ,5X,6HPEAKAS,5X,
     $ 22HPEAK RANGE  JCODE  JWD  /)
  602 FORMAT (1x,3I3,I5,F12.4,F12.5,F12.6,3F12.4,I10,I5)
  605 FORMAT (' NUMBER OF REFLECTIONS PRINTED',I5)
  610 FORMAT (3HHKL,3X,5I3,F8.4,F8.6,F8.3,2F6.4,F7.3,8X,I3)
  615 FORMAT (' MAXIMUM H =',I3,4X,'MAXIMUM K =',I3,4X,'MAXIMUM L =',I3)
  620 FORMAT ('END'/'FINISH')
      END

      SUBROUTINE REFCOD(JCODE,JWD)
c     SUBROUTINE REFCOD(J,K,L,THETA,JCODE,JWD)
C
C     USER SUBROUTINE TO DETERMINE THE REFLECTION CODES JCODE AND JWD
C
C     JCODE = NUMBER OF PEAK SHAPE FUNCTION TO BE USED FOR THIS
C     REFLECTION
C     JWD   = GROUP NUMBER FOR HALF WIDTH AND PEAK ASYMMETRY CORRECTION
C
C     SET DEFAULT VALUES
      JCODE = 1
      JWD  = 0
C

C     INSERT HERE IF STATEMENTS ON H (J),K AND L OR 2 THETA (THETA)
C     TO DETERMINE JCODE AND JWD
C
      RETURN
      END
      SUBROUTINE EXT (J,K,L,IEX)
C
C     SUBROUTINE TO DETERMINE SYSTEMATIC EXTINCTIONS
C     J, K, L  =  MILLER INDICES  (H=J)
C     IEX = RETURN-CODE  (IEX=0 FOR NO EXTINCTION, IEX=1 FOR EXTINCTION)
C
      COMMON /IC/ I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11,
     $ I12,I13
      IEX = 0
      M1 = MOD(J,2)
      M2 = MOD(K,2)
      M3 = MOD(L,2)
      M4 = MOD(K+L,2)
      M5 = MOD(J+L,2)
      M6 = MOD(J+K,2)
      M7 = MOD(J+K+L,2)
C
C     EXTINCTION RULES FOR GENERAL INDICES   (J,K,L)
C
      GO TO (11,12,13,14,15,16,17,18,20), I1
   11 IF (M4 .EQ. 0) GO TO 20
      GO TO 10
   12 IF (M5 .EQ. 0) GO TO 20
      GO TO 10
   13 IF (M6 .EQ. 0) GO TO 20
      GO TO 10
   14 IF (M4 .EQ. 0 .AND. M5 .EQ. 0) GO TO 20
      GO TO 10
   15 IF (M7 .EQ. 0) GO TO 20
      GO TO 10
   16 IF (MOD(-J+K+L,3) .EQ. 0) GO TO 20
      GO TO 10
   17 IF (MOD(J-K+L,3) .EQ. 0) GO TO 20
      GO TO 10
   18 IF (MOD(J-K,3) .EQ. 0) GO TO 20
      GO TO 10
C
C     EXTINCTION RULES FOR INDICES   (0,K,L / ETC.)
C
   20 IF (L .NE. 0) GO TO 30
      GO TO (21,22,23,24,30), I2
   21 IF (M1 .EQ. 0) GO TO 30
      GO TO 10
   22 IF (M2 .EQ. 0) GO TO 30
      GO TO 10
   23 IF (M6 .EQ. 0) GO TO 30
      GO TO 10
   24 IF (MOD(J+K,4) .EQ. 0) GO TO 30
      GO TO 10
   30 IF (K .NE. 0) GO TO 40
      GO TO (31,32,33,34,40), I3
   31 IF (M1 .EQ. 0) GO TO 40
      GO TO 10
   32 IF (M3 .EQ. 0) GO TO 40
      GO TO 10
   33 IF (M5 .EQ. 0) GO TO 40
      GO TO 10
   34 IF (MOD(J+L,4) .EQ. 0) GO TO 40
      GO TO 10
   40 IF (J .NE. 0) GO TO 50
      GO TO (41,42,43,44,50), I4
   41 IF (M2 .EQ. 0) GO TO 50
      GO TO 10
   42 IF (M3 .EQ. 0) GO TO 50
      GO TO 10
   43 IF (M4 .EQ. 0) GO TO 50
      GO TO 10
   44 IF (MOD(K+L,4) .EQ. 0) GO TO 50
      GO TO 10
C
C     EXTINCTION RULES FOR INDICES   (J,J,L / J,-J,L / ETC.)
C
   50 IF (J .NE. K ) GO TO 55
      GO TO (51,52,55), I5
   51 IF (M3 .EQ. 0) GO TO 55
      GO TO 10
   52 IF (MOD(2*J+L,4) .EQ. 0) GO TO 55
      GO TO 10
   55 IF (J .NE.-K ) GO TO 60
      GO TO (56,57,60), I6
   56 IF (M3 .EQ. 0) GO TO 60
      GO TO 10
   57 IF (MOD(2*IABS(J)+L,4) .EQ. 0) GO TO 60
      GO TO 10
   60 IF (J .NE. L ) GO TO 65
      GO TO (61,62,65), I7
   61 IF (M2 .EQ. 0) GO TO 65
      GO TO 10
   62 IF (MOD(2*J+K,4) .EQ. 0) GO TO 65
      GO TO 10
   65 IF (J .NE. -L) GO TO 70
      GO TO (66,67,70), I8
   66 IF (M2 .EQ. 0) GO TO 70
      GO TO 10
   67 IF (MOD(2*IABS(J)+K,4) .EQ. 0) GO TO 70
      GO TO 10
   70 IF (K .NE. L ) GO TO 75
      GO TO (71,72,75), I9
   71 IF (M1 .EQ. 0) GO TO 75
      GO TO 10
   72 IF (MOD(2*K+J,4) .EQ. 0) GO TO 75
      GO TO 10
   75 IF (K .NE. -L) GO TO 80
      GO TO (76,77,80), I10
   76 IF (M1 .EQ. 0) GO TO 80
      GO TO 10
   77 IF (MOD(2*IABS(K)+J,4) .EQ. 0) GO TO 80
      GO TO 10
C
C     EXTINCTION RULES FOR INDICES   (0,0,L / ETC.)
C
   80 IF (K .NE. 0 .OR. L .NE. 0) GO TO 85
      GO TO (81,82,99), I11
   81 IF (M1 .EQ. 0) GO TO 99
      GO TO 10
   82 IF (MOD(J,4) .EQ. 0) GO TO 99
      GO TO 10
   85 IF (J .NE. 0 .OR. L .NE. 0) GO TO 90
      GO TO (86,87,99), I12
   86 IF (M2 .EQ. 0) GO TO 99
      GO TO 10
   87 IF (MOD(K,4) .EQ. 0) GO TO 99
      GO TO 10
   90 IF (J .NE. 0 .OR. K .NE. 0) GO TO 99
      GO TO (91,92,93,94,99), I13
   91 IF (M3 .EQ. 0) GO TO 99
      GO TO 10
   92 IF (MOD(L,3) .EQ. 0) GO TO 99
      GO TO 10
   93 IF (MOD(L,4) .EQ. 0) GO TO 99
      GO TO 10
   94 IF (MOD(L,6) .EQ. 0) GO TO 99
      GO TO 10
   10 IEX = 1
   99 CONTINUE
      RETURN
      END
      SUBROUTINE ERROR(NER)
C
C     SUBROUTINE TO PRINT ERROR-MESSAGES
C
      character*1 itit,icomp
      character*4 mcent,itype,isymb
      integer*4 index
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $      POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $      THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $      CA1,CA2,CA3,
     $      CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000),QS(3000),mcent,itype(80),isymb(1440)
      WRITE (NTOUT,610)
  610 FORMAT(20(1H*))
      GO TO (11,12,13,14,15,16,17,18,19,20,21,22), NER
   11 WRITE (NTOUT,611)
  611 FORMAT (' ----- CAUTION: NON STANDARD EXTINCTION CODE')
      GO TO 100
   12 WRITE (NTOUT,612)
  612 FORMAT (' ----- PROGRAM ERROR STOP')
      STOP
   13 WRITE (NTOUT,613)
  613 FORMAT (' ----- ERROR ON WAVLEN CARD')
      GO TO 10
   14 WRITE (NTOUT,614)
  614 FORMAT (' ----- CRYSTAL SYSTEM IS UNKNOWN')
      GO TO 10
   15 WRITE (NTOUT,615)
  615 FORMAT (' ----- CELL PARAMETER ERROR')
      GO TO 10
   16 WRITE (NTOUT,616)
  616 FORMAT (' ----- UNKNOWN SPACE GROUP NUMBER')
      GO TO 10
   17 WRITE (NTOUT,617)
  617 FORMAT (' ----- BINARY PROFILE FILE IS EMPTY')
      GO TO 10
   18 WRITE (NTOUT,618)
  618 FORMAT (' ----- LAUE GROUP ERROR')
      GO TO 10
   19 GO TO 10
   20 WRITE(NTOUT,620)
  620 FORMAT (' ----- MISSING ATOM TYPE ON FORMFX CARD')
      GO TO 10
   21 WRITE(NTOUT,621)
  621 FORMAT (' ----- TO MANY FORM FACTORS')
      GO TO 10
   22 WRITE(NTOUT,622)
  622 FORMAT (' ----- PEAK PARAMETER FILE IS EMPTY')
      WRITE(NTOUT,722)
  722 FORMAT(8X,'USE FUNCTION FOR WIDTH CALCULATION')
   10 NERO=NERO+1
  100 WRITE(NTOUT,610)
      RETURN
      END
      SUBROUTINE  FREDA(IMIN,IMAX)
      CHARACTER*1  FL,COL,IPLUS,IMINUS,IPOINT,IBLANK,INUM,ICH
      COMMON /FR/  COL(80),FL(15,6),FN(20),NCHAR,KN,KL
      DIMENSION INUM(10)
      DATA IPLUS,IMINUS,IPOINT,IBLANK/1H+,1H-,1H.,1H /
      DATA INUM/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      FN(1)=0
      KN=0
      KL=0
      I=IMIN-1
C
C**** START OF A NEW FIELD
C**** LOOK FOR A NON-BLANK COLUMN
C
  109 A=0.0
      IP=0
      NP=0
      L=0
      S=1.0
  110 I=I+1
      IF(I.GT.IMAX)  GO TO 108
  111 ICH=COL(I)
      IF(L.EQ.0  .AND.  ICH.EQ.IBLANK)  GO TO 110
C**** START OF A FIELD
      L=L+1
      DO 100 J=1,10
      IF(ICH.EQ.INUM(J)) GO TO 101
  100 CONTINUE
      IF(ICH.EQ.IPOINT)  GO TO 102
      IF(ICH.EQ.IPLUS)  GO TO 103
      IF(ICH.EQ.IMINUS)  GO TO 104
      IF(L.GT.1)  GO TO 105
      GO TO 150
C**** START OF A LITERAL FIELD BY A CHARACTER WHICH IS OTHER THAN 0-9+-.
C
C**** NUMERIC FIELD FOUND
C
  101 IF(J.EQ.10)  J=0
      IF(IP.EQ.1)  NP=NP+1
  106 A=10.0*A + J
      GO TO 110
  102 IP=1
      GO TO 110
  103 IF(L.GT.1)  GO TO 105
      S=1.0
      GO TO 110
  104 IF(L.GT.1)  GO TO 105
      S=-1.0
      GO TO 110
  108 IF(L.GT.0)  GO TO 105
      GO TO 120
C**** END OF NUMERIC FIELD
  105 A = S*A/10.0**NP
      KN=KN+1
      FN(KN)=A
      IF(ICH.EQ.IPLUS .OR. ICH.EQ.IMINUS)   I=I-1
      GO TO 109
C
C**** LITERAL FIELD
C
  150 KL=KL+1
  151 FL(KL,L) = ICH
      L=L+1
      IF(L.GT.NCHAR)  GO TO 109
      I=I+1
      IF(I.GT.IMAX)  GO TO 152
      ICH=COL(I)
      IF(ICH.EQ.IBLANK)  GO TO 152
      GO TO 151
C**** END OF LITERAL FIELD DEFINED BY BLANK
  152 DO 153 J=L,NCHAR
  153 FL(KL,J) = IBLANK
      GO TO 109
C
C**** FINISHED
C
  120 RETURN
      END

      FUNCTION FMULT(KH,KK,KL)
      character*4 mcent,itype,isymb
      integer*4 index
      CHARACTER*1 ITIT,ICOMP
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON INDEX(3000),QS(3000)  ,mcent,itype(80),isymb(1440)
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16),LAUE
C
C     LAUE GROUP -1
C
    1 FAC=2.0
      GO TO 9999
C
C     LAUE GROUP 2/M (Y UNIQUE)
C
    2 IF (KK) 101,104,101
  101 IF (KL) 105,103,105
  103 IF (KH) 105,104,105
  104 FAC=2.0
      GO TO 9999
  105 FAC=4.0
      GO TO 9999
C
C     LAUE GROUP 2/M (Z UNIQUE)
C
    3 IF (KL) 110,113,110
  110 IF (KK) 114,112,114
  112 IF (KH) 114,113,114
  113 FAC=2.0
      GO TO 9999
  114 FAC=4.0
      GO TO 9999
C
C     LAUE GROUP  2/M (X UNIQUE)
C
   16 IF(KH) 115,118,115
  115 IF(KK) 119,116,119
  116 IF(KL) 119,118,119
  118 FAC = 2.0
      GO TO 9999
  119 FAC = 4.
      GO TO 9999
C
C     LAUE GROUP MMM
C
    4 IF (KH) 122,120,122
  120 IF (KK) 121,125,121
  121 IF (KL) 126,125,126
  122 IF (KK) 124,121,124
  124 IF (KL) 127,126,127
  125 FAC=2.0
      GO TO 9999
  126 FAC=4.0
      GO TO 9999
  127 FAC=8.0
      GO TO 9999
C
C     LAUE GROUP 4/M
C
    5 IF (KH) 132,130,132
  130 IF (KK) 131,133,131
  131 IF (KL) 135,134,135
  132 IF (KL) 135,134,135
  133 FAC=2.0
      GO TO 9999
  134 FAC=4.0
      GO TO 9999
  135 FAC=8.0
      GO TO 9999
C
C     LAUE GROUP 4/MMM
C
    6 IF (KH) 142,140,142
  140 IF (KK) 141,147,141
  141 IF (KL) 149,148,149
  142 IF (KK) 144,143,144
  143 IF (KL) 149,148,149
  144 IF (KL) 146,145,146
  145 IF (KK-KH) 149,148,149
  146 IF (KK-KH) 150,149,150
  147 FAC=2.0
      GO TO 9999
  148 FAC=4.0
      GO TO 9999
  149 FAC=8.0
      GO TO 9999
  150 FAC=16.0
      GO TO 9999
C
C     LAUE GROUP M3
C
    7 IF (KH) 157,155,157
  155 IF (KK) 156,162,156
  156 IF (KL) 164,162,164
  157 IF (KK) 159,156,159
  159 IF (KL) 160,164,160
  160 IF (KH-KK) 165,161,165
  161 IF (KK-KL) 165,163,165
  162 FAC=6.0
      GO TO 9999
  163 FAC=8.0
      GO TO 9999
  164 FAC=12.0
      GO TO 9999
  165 FAC=24.0
      GO TO 9999
C
C     LAUE GROUP M3M
C
    8 IF (KH) 173,170,173
  170 IF (KK) 171,182,171
  171 IF (KL) 172,182,172
  172 IF (KK-KL) 185,184,185
  173 IF (KK) 176,174,176
  174 IF (KL) 175,182,175
  175 IF (KH-KL) 185,184,185
  176 IF (KL) 178,177,178
  177 IF (KH-KK) 185,184,185
  178 IF (KH-KK) 180,179,180
  179 IF (KH-KL) 185,183,185
  180 IF (KH-KL) 181,185,181
  181 IF (KK-KL) 186,185,186
  182 FAC=6.0
      GO TO 9999
  183 FAC=8.0
      GO TO 9999
  184 FAC=12.0
      GO TO 9999
  185 FAC=24.0
      GO TO 9999
  186 FAC=48.0
      GO TO 9999
C
C     LAUE GROUP -3 (RHOMBOHEDRAL)
C
    9 IF (KH-KK) 190,188,190
  188 IF (KH-KL) 190,189,190
  189 FAC=2.0
      GO TO 9999
  190 FAC=6.0
      GO TO 9999
C
C     LAUE GROUP -3M(RHOMBOHEDRAL)
C
   10 IF (KH-KK) 192,191,192
  191 IF (KH-KL) 195,194,195
  192 IF (KH-KL) 193,195,193
  193 IF (KK-KL) 1931,195,1931
 1931 IF (KH-KK) 1933,1932,1933
 1932 IF (KL) 196,195,196
 1933 IF (KH+KK) 196,1932,196
  194 FAC=2.0
      GO TO 9999
  195 FAC=6.0
      GO TO 9999
  196 FAC=12.0
      GO TO 9999
C
C     LAUE GROUP -3  (HEXAGONAL)
C
   11 IF (KH) 199,197,199
  197 IF (KK) 199,198,199
  198 FAC=2.0
      GO TO 9999
  199 FAC=6.0
      GO TO 9999
C
C     LAUE GROUP -3M (HEXAGONAL)
C
   12 IF (KH) 201,200,201
  200 IF (KK) 205,204,205
  201 IF (KK) 202,205,202
  202 IF (KH-KK) 206,203,206
  203 IF (KL) 206,205,206
  204 FAC=2.0
      GO TO 9999
  205 FAC=6.0
      GO TO 9999
  206 FAC=12.0
      GO TO 9999
C
C     LAUE GROUP 6/M
C
   13 IF (KH) 211,210,211
  210 IF (KK) 211,212,211
  211 IF (KL) 214,213,214
  212 FAC=2.0
      GO TO 9999
  213 FAC=6.0
      GO TO 9999
  214 FAC=12.0
      GO TO 9999
C
C     LAUE GROUP 6/MMM
C
   14 IF (KH) 222,220,222
  220 IF (KK) 221,225,221
  221 IF (KL) 227,226,227
  222 IF (KK) 223,221,223
  223 IF (KH-KK) 224,221,224
  224 IF (KL) 228,227,228
  225 FAC=2.0
      GO TO 9999
  226 FAC=6.0
      GO TO 9999
  227 FAC=12.0
      GO TO 9999
  228 FAC=24.0
      GO TO 9999
C
C     LAUE GROUP -3M (ROTATED, -31M)
C
   15 IF (KH) 231,230,231
  230 IF (KK) 233,234,233
  231 IF (KK) 232,233,232
  232 IF (KH-KK) 236,235,236
  233 IF (KL) 236,235,236
  234 FAC=2.0
      GO TO 9999
  235 FAC=6.0
      GO TO 9999
  236 FAC=12.0
 9999 FMULT = FAC
      RETURN
      END

      SUBROUTINE SYMCRD
      character*4 mcent,itype,isymb
      integer*4 IEXT,ISPACE,ICENT,LTRAN,NSYM,ITRAN
      CHARACTER*1 ITIT,ICOMP,IXYZ,NUMB,ISLASH,IBLANK,ICOMMA,IPLUS,IMINUS
c     CHARACTER*1 ITIT,ICOMP,IXYZ,ISTAR,NUMB,ISLASH,IBLANK,ICOMMA,
c    $            IPLUS,IMINUS
c     CHARACTER*8 LCENT
      COMMON /IC/  IC(13)
      DIMENSION NUMB(10),IXYZ(3)
c     DIMENSION NUMB(10),IXYZ(3),LCENT(2)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $        MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON IEXT,ISPACE,ICENT,LTRAN,zzzz1,NSYM,RL(3,4)
     $ ,RS(48,3,4),ITRAN(30),zzzz3(48,30),NC(13),zzzz2(3923)
     $ ,mcent,itype(80),isymb(48,30)
      DATA IXYZ/1HX,1HY,1HZ/
c     DATA ISTAR/1H*/
      DATA NUMB/1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9,1H0/
      DATA ISLASH,IBLANK,ICOMMA,IPLUS,IMINUS/1H/,1H ,1H,,1H+,1H-/
c     DATA LCENT/8HACENTRIC,7HCENTRIC/
      REWIND ISYMF
      IF(IEXT.EQ.0)  GO TO 4
    3 READ(ISYMF,95) IC,ISG
      IF(ISG.NE.ISPACE)  GO TO 3
      DO 195  I = 1,13
  195 NC(I) = IC(I)
      IF(ISG.EQ.230)  GO TO 5
   95 FORMAT(13I2,42X,I4)
    4 READ(ISYMF,94) IDUM
   94 FORMAT(68X,I4)
      IF(IDUM.NE.230)  GO TO 4
    5 READ(ISYMF,100) ISG,NSYM,ICENT,LTRAN,(ITRAN(I),I=1,30)
  100 FORMAT(I5,3I3,30I1)
      IF(ISG.EQ.ISPACE) GO TO 20
      DO  10 I = 1,NSYM
   10 READ(ISYMF,110) IDUM
  110 FORMAT(I4)
      GO TO 5
   20 ICENT = ICENT + 1
      LTRAN = LTRAN + 1
      I = 1
      DO 23 K=1,3
   23 RL(K,1) = 0.0
      IF(LTRAN.EQ.1)   GO TO 26
      DO 25 L = 2,LTRAN
      DO 25 K = 1,3
      IF(ITRAN(I+1).NE.0) GO TO 24
      RL(K,L) = 0.0
      GO TO 25
   24 RL(K,L) = FLOAT(ITRAN(I))/FLOAT(ITRAN(I+1))
   25 I = I + 2
   26 DO 35 N = 1,NSYM
      READ(ISYMF,120) (ITRAN(M),M=1,16)
  120 FORMAT(3(I4,2I2,2I3,1X),I3)
      IF(ITRAN(16).NE.N)  GO TO 900
      M = 1
      DO 30 K=1,3
      IF(ITRAN(M+1).NE.0) GO TO 27
      RS(N,K,4) = 0.0
      GO TO 28
   27 RS(N,K,4) = FLOAT(ITRAN(M))/FLOAT(ITRAN(M+1))
   28 M = M + 2
      DO 30 L = 1,3
      RS(N,K,L) = ITRAN(M)
      M = M + 1
   30 CONTINUE
      DO 310 KK=1,30
  310 ISYMB(N,KK) = IBLANK
      K = 0
      I = 1
      DO 360 IS = 1,3
      IF(ITRAN(I).EQ.0) GO TO 320
      K = K+1
      ISYMB(N,K) = NUMB(ITRAN(I))
      K = K+1
      ISYMB(N,K) = ISLASH
      K = K + 1
      ISYMB(N,K) = NUMB(ITRAN(I+1))
  320 I = I + 2
      DO 350 KX =1,3
      IF(ITRAN(I).EQ.0)  GO TO 350
      IF(ITRAN(I).GE.0)  GO TO 330
  325 K = K + 1
      ISYMB(N,K) = IMINUS
      ITRAN(I) = -ITRAN(I)
      K = K + 1
      GO TO 335
  330 K = K + 1
      IF(K.EQ.1)  GO TO 335
      IF(ISYMB(N,K-1).EQ.IBLANK)  GO TO 335
      ISYMB(N,K) = IPLUS
      K = K + 1
  335 ISYMB(N,K) = IXYZ(KX)
  350 I = I+1
      IF(IS.EQ.3)  GO TO 360
      K = IS*10
      ISYMB(N,K) = ICOMMA
      K = K + 1
      ISYMB(N,K) = IBLANK
  360 CONTINUE
   35 CONTINUE
      IF(LTRAN.EQ.1)  GO TO 460
      IF(LTRAN.EQ.2) GO TO 400
      IF(LTRAN.EQ.4)  GO TO 450
      IF(LTRAN.NE.3)  GO TO 900
      MCENT = 'R-'
      GO TO 1000
  400 IF(RL(1,2).EQ.0.)  GO TO 410
      IF(RL(2,2).EQ.0.)  GO TO 420
      IF(RL(3,2).EQ.0.)  GO TO 430
      MCENT = 'I-'
      GO TO 1000
  410 MCENT = 'A-'
      GO TO 1000
  420 MCENT = 'B-'
      GO TO 1000
  430 MCENT = 'C-'
      GO TO 1000
  450 MCENT = 'F-'
      GO TO 1000
  460 MCENT = 'P '
      GO TO 1000
  900 WRITE(NTOUT,910) ISYMF,ISPACE
  910 FORMAT(1x,3H***,' ERROR IN READING THE SYMMETRY INFORMATION',
     1 ' FROM FILE',I5,' FOR SPACE GROUP NR',I6)
 1000 RETURN
      END
      SUBROUTINE MLAUE
      character*4 mcent,itype,isymb
      character*1 itit,icomp
      integer*4 iext,ispace
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON IEXT,ISPACE,zz1(5998),mcent,itype(80),isymb(1440)
      NSPACE = IABS(ISPACE)
      IF(NSPACE.GE.75) GO TO 50
      IF(NSPACE.GE.16)  GO TO 40
      IF(NSPACE.GE.3)  GO TO 20
      LAUE = 1
      GO TO 300
   20 IF(ISPACE.GT.0) GO TO 30
      LAUE = 2
      GO TO 300
   30 LAUE = 3
      GO TO 300
   40 LAUE = 4
      GO TO 300
   50 IF(NSPACE.GE.195) GO TO 70
      IF(NSPACE.GE.143) GO TO 90
      IF(NSPACE.GE.89) GO TO 60
      LAUE = 5
      GO TO 300
   60 LAUE = 6
      GO TO 300
   70 IF(NSPACE.GE.207) GO TO 80
      LAUE = 7
      GO TO 300
   80 LAUE = 8
      GO TO 300
   90 IF(NSPACE.GE.168)  GO TO 130
      IF(NSPACE.GE.149)  GO TO 100
      IF(NSPACE.NE.146.OR.NSPACE.NE.148) GO TO 110
      LAUE = 9
      GO TO 105
  100 IF(NSPACE.LE.159)  GO TO 120
      IF(NSPACE.GE.162.AND.NSPACE.LE.165) GO TO 122
      LAUE = 10
  105 IF(ISPACE.LT.0)  LAUE = LAUE + 2
      GO TO 300
  110 LAUE = 11
      GO TO 300
  120 IF(MOD(NSPACE,2).EQ.0) GO TO 124
      GO TO 125
  122 IF(NSPACE.LE.163) GO TO 125
  124 LAUE = 12
      GO TO 300
  125 LAUE = 15
      GO TO 300
  130 IF(NSPACE.GE.177) GO TO 140
      LAUE = 13
      GO TO 300
  140 LAUE = 14
  300 RETURN
      END
      SUBROUTINE OUTCRD (IP)
      CHARACTER*8 LCENT
      CHARACTER*1 ITIT,ICOMP
      character*4 mcent,itype,isymb
      integer*4 iext,ispace,icent,ltran,nsym,itran
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF
      COMMON IEXT,ISPACE,ICENT,LTRAN,zzzz2,NSYM,RL(3,4)
     $       ,RS(48,3,4),ITRAN(30),zzzz3(48,30),NC(13),DCP(6),
     $        JUN(119),RI(101),FSI(101),FAI(101),DFSI(101),DFAI(101),
     $        JUN1(293),
     $        zzzz4(20,4),IPFX(21),FX(1000),zzzz1(1899)
     $        ,mcent,itype(20,4),isymb(48,30)
      DIMENSION LCENT(2),KEYCEL(13)
c     DIMENSION ICELL(13),LCENT(2),KEYCEL(13)
      DATA LCENT/8HACENTRIC,7HCENTRIC /
c     DATA ICELL,LCENT/3HCUB ,3HTET ,3HORT ,3HHEX ,4HMON1,4HMON2,4HTRIC,
c    $     3HROB ,3HRRE ,3HRHE ,3HHRO ,3HHRR ,4HMON3,8HACENTRIC,
c    $     7HCENTRIC /
      DATA KEYCEL/61,29,21,3741,1685,405,1365,3965,3965,3741,3965,
     $            3965,85/
      IF(IP-2)  5,40,50
    5 WRITE(NTCRD,100) ITIT
      WRITE(NTCRD,110) ICOMP,DCP
      IF(ABS(POV(1))+ABS(POV(2))+ABS(POV(3)).LE.0.)  GO TO 7
      WRITE(NTCRD,112)  POV,PREFOF
    7 CONTINUE
      IF(NF)  30,30,10
   10 DO 20 N=1,NF
      JUNK = IPFX(N)-1
      JUNK1 = IPFX(N+1) - 2
      DO 15 J=JUNK,JUNK1,2
      WRITE(NTCRD,120) (ITYPE(N,I),I=1,4),FX(J),FX(J+1)
   15 CONTINUE
   20 CONTINUE
   30 IF(ISPACE.EQ.0) GO TO 35
      WRITE(NTCRD,140) LCENT(ICENT),MCENT,KEYCEL(ISYST)
      WRITE(NTCRD,150) ((ISYMB(N,I),I=1,30),N=1,NSYM)
   35 RETURN
C----SECOND ENTRY. WRITE PEAK SHAPE FUNCTION
   40 WRITE(NTCRD,155)
      WRITE(NTCRD,157) (RI(I),FSI(I),FAI(I),DFSI(I),DFAI(I),I=51,101)
      RETURN
C----THIRD ENTRY
   50 STMAX = SIN(THMAX*RD/2.)/XLAMDA
      STMIN = SIN(THMIN*RD/2.)/XLAMDA
      WRITE(NTCRD,115) MH,MK,ML,STMAX,STMIN
      FAC = .99
      LP = 0
      RANGE = ABS(RANGE)
      WRITE(NTCRD,160) XLAMDA,FAC,IXN,LP,RANGE,POLRA
      RETURN
C
C     FORMAT STATEMENTS
C
  110 FORMAT('CELL',3X,6A1,3F8.4,3F9.5,F7.0)
  112 FORMAT('PREVEC',4X,3F5.1,F10.6)
  100 FORMAT('LABEL ',74A1)
  115 FORMAT(6HMAXHKL,7X,3I4,2F8.4)
  120 FORMAT(6HFORMFX,1X,4A1,1X,F8.5,F8.3)
  150 FORMAT(6HSYMTRY,1X,30A1)
  155 FORMAT('PEAKF    1   51')
  157 FORMAT(12X,5E12.5)
  160 FORMAT(6HCONDIT,7X,2F8.5,8X,2I3,F6.2,7X,F8.5)
  140 FORMAT('LATICE',2X,A1,2X,A1,I8)
      END
      SUBROUTINE PROFAN
C     PURPOSE:  1) TO DETERMINE HALF WIDTH AND PEAK ASYMMETRY OF AS
C     MANY PEAKS IN THE PATTERN AS POSSIBLE
C
C     2) TO FIND A NUMERICAL FUNCTION DESCRIBING THEIR
C     DEPENDENCE ON 2 THETA
C
C     WRITTEN BY A.HEPP, INSTITUT FUER KRISTALLOGRAPHIE UND
C     PETROGRAPHIE, ETH, 8092 ZURICH
C     VERSION OF MAY 1982
      CHARACTER*1 COL,NL,ITIT,ICOMP,dum(74)
      character*4 mcent,itype,isymb
      integer*4 iext,ispace
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      COMMON /PA/ ICURV,IHAIN,IHAOUT,IHW,IPAS,IWHA,JL,JU,IPRANA,
     $            CTMIN,HWMX,QJT,QINT,TSTART,TSTEP,
     $            ZP,HWAR(100),PASAR(100)
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF

      COMMON IEXT,ISPACE,A(2000),HW(100),PAS(100),RI(101),FSI(101),
     $       FAI(101),DFSI(101),DFAI(101),
     $       CARR(100),TARR(100),
     $       TMAX(500),CMAX(500),SARR(100),ABCD(4,101),zzzz1(1589)
     $       ,mcent,itype(80),isymb(1440)
      EQUIVALENCE (THMIN,TTMIN),(RD,PI180)
      DET(A1,A2,A3,A4)=A1*A4-A2*A3
      NCURV = 0
      IF(IHW.NE.2.OR.IPAS.NE.2)  GO TO 300
      WRITE(NTOUT,301)
  301 FORMAT(' DO NOT PERFORM AN ANALYSIS OF THE PATTERN ')
      IPRANA = 0
      GO TO 315
C----READ AND WRITE LABEL OF PATTERN
  300 WRITE(NTOUT,1000)
 1000 FORMAT(' PERFORM ANALYSIS OF PATTERN ')
      REWIND IPROF
      READ(IPROF,3000,END=305) (itit(I),I=1,74)
 3000 format(74a1)
CTAM  IF(EOF(IPROF)) 305,307
      GO TO 307
  305 CALL ERROR(7)
      GO TO 113
  307 WRITE(NTOUT,1001) (itit(I),I=1,74)
 1001 FORMAT(' LABEL OF PATTERN IS: ',74A1)
      READ(IPROF,3001,END=305) TMI,TMA,STEP
 3001 format(3f10.4)
CTAM  IF(EOF(IPROF)) 305,310
  310 IF(THMIN.LT.TMI) THMIN = TMI
      IF(THMAX.GT.TMA) THMAX = TMA
      WRITE(NTOUT,1003) THMIN,THMAX
 1003 FORMAT(' THE PATTERN GOES FROM 2THETA ',F8.2,' TO',F8.2)
C    SET DIMENSION LIMIT OF TARR AND CARR
  315 IDTARR = 100
      MSTEP = 100
C     SET PRINT FLAG FOR DIAGNOSTICS (IPRI = 1 FOR PRINT)
      IPRI = 0
C
C     SET SOME PARAMETERS AND DEFAULT VALUES
C
      IPST = -2
C     IHW, IPAS   = 0: CALCULATE HW OR PAS FROM PATTERN FILE IPROF
C     = 1 TAKE CALCULATED VALUES FROM FILE IHAIN
C     (STANDARD PATTERN)
C     = 2 CALCULATE THEM BY FORMULAE
C     IWHA = 1: WRITE ARRAYS HWAR AND PASAR ON FILE IHAOUT
C     IWHA =-1: READ UNSMOOTHED VALUES OF HW AND PA
C     STEPLENGTH OF THESE ARRAYS IN DEGREES TWO-THETA
C
      EPSO = 1.0E-03
      PAEPS=1.0E-6
C     ROUND FOR A RANGE OF MULTIPLES OF 1 DEGREE
      IT=TTMIN
      TTMAX = THMAX
      TSTART=FLOAT(IT)
      IT=(TTMAX+1.0)
      TEND=FLOAT(IT)
      TSTEP = 1.0
    2 ISTART=TSTART/TSTEP
      IEND=TEND/TSTEP
      NSTEPS=IEND-ISTART+1
      IF(NSTEPS.LE.MSTEP)  GO TO 5
      TSTEP = TSTEP + .5
      GO TO 2
    5 QINT=1.0/TSTEP
      IHPRG = 3
C     MINIMAL PEAK RANGE IN DIFFRACTOMETER STEPS
      IPRG=2*IHPRG+1
      IRM1=IPRG-1
      IHSRG = 5
      FHSRG=FLOAT(IHSRG)
C     SQUARED HALFWIDTH OF WEIGHT FUNCTION IN SMOOTHING PROCEDURE
      BSQ=FHSRG*FHSRG
C     STEPLENGTH ON PATTERN FILE
      T12 = STEP
      QJT=1.0/T12
C     POINTS LYING WITHIN TCA*T12 AND TCB*T12 AWAY FROM THE PEAK CENTER
C     ARE ACCEPTED IN THE CALCULATION OF HW AND PAS
      TCA=2.5
      TCB=7.0
CTAM  IF(IPRANA.EQ.0)  GO TO 250
C***  READ STORED VALUES OF STANDARD PEAK
      READ(ICURV,1005) (COL(I),I=1,21)
 1005 FORMAT(A4,A2,18A4,A2)
      WRITE(NTOUT,1007) (COL(I),I=1,21)
 1007 FORMAT(' STANDARD PEAK FUNCTION READ WITH ',A4,A2,18A4,A2)
      READ(ICURV,1009)  RI(1)
 1009 FORMAT(15X,F10.2)
      IF(RANGE.LE.0.0.AND.RI(1).NE.0.0)  RANGE = RI(1)
      READ(ICURV,1016) (RI(I),FSI(I),FAI(I),DFSI(I),DFAI(I),I=51,101)
 1016 FORMAT(12X,5E12.4)
    7 NCURV = 101
C     GENERATE LEFT HALF OF ASYMMETRY VALUES OF STANDARD PEAK
      DO 8  I=52,NCURV
      K = 102 - I
    8 FAI(K) = -FAI(I)
   11 IF(IWHA) 156,12,12
   12 IF(IHW.GT.0.AND.IPAS.GT.0)  GO TO 250
C     CHECK IF STANDARD PEAK HAS BEEN READ
      IF(NCURV)  13,13,14
   13 CALL ERROR(12)
  113 IPRANA = 0
      IF(IHW.LE.0) IHW = 2
      IF(IPAS.LE.0) IPAS = 2
      GO TO 250
   14 NMAX=(NCURV+1)/2
      NMAX1=NMAX+1
      FMAX=FSI(NMAX)
      RISTEP=RI(NMAX1)
C     CALCULATE COEFFICIENTS FOR THE SPLINE INTERPOLATION
C     OF THE TABULATED ASYMMETRY VALUES
      CALL INTPOL(1,101,FAI,ABCD)
C***  READ PATTERN FILE FOR POSITIONS OF MAXIMA
      IXX=0
      IT = 0
C----GET BEGIN OF RANGE
   16 READ(IPROF,3002,END=17) T,C,SIG
 3002 format(f9.4,f9.0,f11.5)
CTAM  IF(EOF(IPROF)) 17,18
      GO TO 18
   17 CALL ERROR(7)
      GO TO 113
   18 IF(T.LT.TTMIN) GO TO 16
      GO TO 30
   20 READ(IPROF,3002,END=64) TH,C,SIG
CTAM  IF(EOF(IPROF)) 64,25
   25 T = TH
   30 IF(T.GT.TTMAX) GO TO 61
      IT=IT+1
C     FOR A RANGE OF IPRG POINTS STORE THE CURRENT TWO-THETA
C     AND COUNTS VALUES
      TARR(IT)=T
      CARR(IT)=C
      SARR(IT) = SIG
      IF(IT.LT.IPRG) GO TO 20
C     CHECK IF THE CENTER IHPRG+1 COINCIDES WITH A PEAK MAXIMUM
CTAM  ISHFT1=ISHFT2=0
      ISHFT1=0
      ISHFT2=0
      DO 35 II=1,IHPRG
      DT=TARR(II+1)-TARR(II)
      IF(DT.LE.1.5*T12) GO TO 40
      ISHFT1=II
      GO TO 45
   40 IF(CARR(II).LT.CARR(II+1)) GO TO 45
      IF(II.EQ.1) GO TO 41
      IF(CARR(II-1).LT.CARR(II+1)) GO TO 45
   41 ISHFT1=II
   45 DT=TARR(II+IHPRG+1)-TARR(II+IHPRG)
      IF(DT.LE.1.5*T12) GO TO 50
      ISHFT2=IHPRG+II-1
      GO TO 35
   50 IF(ISHFT2.GT.0) GO TO 35
      IF(CARR(II+IHPRG+1).LT.CARR(II+IHPRG)) GO TO 35
      IF(II.EQ.IHPRG) GO TO 34
      IF(CARR(II+IHPRG+2).LT.CARR(II+IHPRG)) GO TO 35
   34 ISHFT2=1
   35 CONTINUE
      ISHFT=MAX0(ISHFT1,ISHFT2)
      IF(ISHFT.EQ.0) GO TO 51
      IT=IPRG-ISHFT
      GO TO 58
   51 CX=CARR(IHPRG+1)
      IF(CX.GE.CTMIN) GO TO 55
      GO TO 57
C     WE HAVE FOUND AN ACCEPTABLE MAXIMUM WITH A RANGE
C     OF AT LEAST IPRG POINTS
   55 IXX=IXX+1
      TMAX(IXX)=TARR(IHPRG+1)
      CMAX(IXX)= CX
      IF(CX.GT.20./SARR(IHPRG+1))  TCTOFF = TMAX(IXX)
   57 IT=1
      ISHFT = IRM1
   58 DO 59 II = 1,IT
      TARR(II) = TARR(ISHFT + II)
   59 CARR(II) = CARR(ISHFT + II)
      GO TO 20
C     END OF PROFILE. HAVE THERE ANY PEAKS BEEN FOUND
   64 TTMAX = TH
   61 IF(IXX.GT.2)  GO TO 62
      WRITE(NTOUT,1135)
 1135 FORMAT(' PROFAN HAS FOUND LESS THAN 3 ACCEPTABLE PEAKS. ',
     $ 'THE PROFILE ANALYSIS IS TERMINATED.'/
     $ '  USE HALF WIDTH AND PEAKAS FUNCTIONS INSTEAD.')
      IF(IHW.LE.0) IHW = 2
      IF(IPAS.LE.0) IPAS = 2
      GO TO 250
   62 IF(IPRI.EQ.0)  GO TO 63
      WRITE(NTOUT,904)
  904 FORMAT('  TMAX CMAX ')
      WRITE(NTOUT,2000) (TMAX(N),CMAX(N),N=1,IXX)
 2000 FORMAT(2X,10E12.4)
      WRITE(NTOUT,2000) TCTOFF
 2001 FORMAT('  CUTOFF FOR HW AND PAS AT ',F12.4)
C***  READ PATTERN FILE TO CALCULATE HALFWIDTH HW AND ASYMMETRY
C***  PARAMETER PAS OF THE PEAKS FOUND BEFORE
   63 WRITE(NTOUT,1060) TCTOFF,IXX
 1060 FORMAT(' 2 THETA MAXIMUM USED IN PATTERN ANALYSIS IS:',F8.2/
     $ '0THE NUMBER OF SUITABLE PEAKS FOUND IN THIS REGION IS',I3)
      REWIND IPROF
      READ(IPROF,3005) DUM
 3005 format(74a1)
      READ(IPROF,3005) DUM
      ISENT=0
      I=1
      TX=TMAX(1)
      CX=CMAX(1)
      J=0
      TXL = TTMIN
      JD=-2
      COLD=0.0
      CVOLD=0.0
   70 READ(IPROF,3006,END=80) T,C
 3006 format(f9.4,f9.0)
CTAM  IF(EOF(IPROF)) 80,75
   75 IF(T.LT.TXL) GO TO 70
      IF(T.GT.TTMAX) GO TO 80
      GO TO 85
   80 ISENT=1
      GO TO 90
   85 J=J+1
      TARR(J)=T
      CARR(J)=C
      CDIFF=C-COLD
      CDIFF2=C-CVOLD
      CVOLD=COLD
      COLD=C
C    DIMENSION CHECK.
      IF(J.LT.IDTARR) GO TO 88
C----ARRAY FULL. SHIFT DATA BY 10 POSITIONS
C    HAS MAXIMUM BEEN FOUND ALREADY
      IF(JD)  91,91,86
   86 JD=JD + 1
      IF(JD-IDTARR/2) 87,90,90
   87 JX = JX - 10
C     CORRECT JD
      JD = JD - 1
   91 J = 0
      DO 92 K=11,IDTARR
      J = J + 1
      TARR(J) = TARR(K)
   92 CARR(J) = CARR(K)
   88 IF(T.LT.TX) GO TO 70
C     WE PASS THE POSITION OF A MAXIMUM
      IF(T.EQ.TX) JX=J
      JD=JD+1
      IF(JD.LT.IHPRG) GO TO 70
      IF(CDIFF.LT.0.0) GO TO 70
      IF(CDIFF2.LT.0.0) GO TO 70
   90 JL1=JX-IHPRG-1
      DO 95 K=1,JL1
      IF(CARR(JL1+1-K).LT.CARR(JL1+2-K)) GO TO 95
      IF(CARR(JL1+1-K).LT.CARR(JL1+3-K)) GO TO 95
      JD2=IHPRG+K-1
      GO TO 100
   95 CONTINUE
      JD2=IHPRG+JL1
  100 JD=MIN0(JD,JD2)
      JL=JX-JD
      JU=JX+JD
C     NOW WE KNOW THE WHOLE RANGE OF THIS PEAK (2*JD+1 POINTS)
      IF(IPRI.EQ.1) WRITE(NTOUT,2005)JX,TX,CX,FMAX,RISTEP
 2005 FORMAT(' JX TX CX FMAX RISTEP',I5,4E12.4)
C     GET A MORE PRECISE POSITION OF THE MAXIMUM
      CALL FINDPK(CARR,JX,TS,CS,JL,JU)
      DELTJ=TS-FLOAT(JX)
      DELT=T12*DELTJ
      TS=TX+DELT
      IF(IPRI.EQ.1) WRITE(NTOUT,2015)TS,CS
 2015 FORMAT(' TS CS',2E12.4)
      EPS=EPSO*CS
      CCMIN=AMAX1(CARR(JL),CARR(JU))
      ZMIN=CCMIN/CS
C     COUNTS BELOW THE GIVEN PERCENTAGE ZP OF THE DIFFERENCE
C     CS - CCMIN ARE IGNORED IN THE DETERMINATION OF HW AND PAS
      ZREF=ZMIN+ZP*(1.0-ZMIN)
      IPRGE=JU-JL+1
      IF(IPRI.EQ.1) WRITE(NTOUT,2019)IPRGE
 2019 FORMAT(' IPRGE',I5)
      DO 105 L=1,IPRGE
      HW(L)=0.0
  105 PAS(L)=0.0
      DO 110 K=JL,JU
C     TWO-THETA DEVIATION FROM THE POSITION OF THE MAXIMUM
      R=TARR(K)-TS
      RO=ABS(R)
      IF(RO.LT.TCA*T12) GO TO 110
      IF(RO.GT.TCB*T12) GO TO 110
      KN=2*JX-K
      CPP=CARR(K)
      TJN=FLOAT(KN)+2.0*DELTJ
      JN=TJN
      DTJN=TJN-FLOAT(JN)
      FJN=CARR(JN)
      CNN=FJN+DTJN*(CARR(JN+1)-FJN)
C     SYMMETRICAL PART
      CPNH=0.5*(CPP+CNN)
      ZO=CPNH/CS
      IF(ZO.LT.ZREF) GO TO 110
      ZO=ZO*FMAX
C     ASYMMETRICAL PART
      IF(IPAS.LE.0) ZAO=(CPNH-CPP)/(CPNH+EPS)
      IF(R.LT.0.0) ZAO=-ZAO
      IF(IPRI.EQ.1) WRITE(NTOUT,2014)R,CPP,CNN,EPS,ZAO
 2014 FORMAT(' R CPP CNN EPS ZAO ',5E12.4)
C     COMPARE THE VALUE OF THE SYMMETRICAL PART WITH THOSE OF THE
C     STANDARD PEAK TO FIND OUT WHAT DEVIATION RII IN UNITS OF THE
C     STANDARD PEAK BELONGS TO THIS VALUE
C     (N.B.: THE STANDARD PEAK HAS HALFWIDTH ONE)
      DO 115 L=NMAX1,NCURV
      LL=L
      ZLL=FSI(L)
      IF(ZLL.LE.ZO) GO TO 120
  115 CONTINUE
      GO TO 110
  120 ZL1=FSI(LL-1)
      RLL=RI(LL)
      RL1=RI(LL-1)
      RII=0.5*(RL1+RLL)
      ZD=ZL1-ZLL
C     IF ZL1-ZLL NE 0.0 GET RII BY LINEAR INTERPOLATION
      IF(ZD.NE.0.0) RII=RISTEP*(ZL1-ZO)/ZD+RL1
C     DIVIDE THE OBSERVED TWO-THETA DEVIATION RO BY RII TO GET
C     AN ESTIMATE OF THE HALFWIDTH
      IF(RII.GT.0.0) HW(K-JL+1)=RO/RII
      IF(IPAS.GT.0) GO TO 110
C     INTERPOLATE THE TABULATED ASYMMETRY VALUES BY SPLINES
      RIJ=RII/RISTEP+FLOAT(NMAX)
      CALL FINTPL(1,101,ABCD,RIJ,FAII)
      IF(IPRI.EQ.1) WRITE(NTOUT,2016)RO,RII,RIJ,ZAO,FAII
 2016 FORMAT(' RO RII RIJ ZAO FAII ',5E12.4)
C     DIVIDE THE OBSERVED VALUE ZAO BY FAII FOR AN ESTIMATE
C     OF THE ASYMMETRY PARAMETER
      IF(FAII.NE.0.0) PAS(K-JL+1)=ZAO/FAII
  110 CONTINUE
      IF(IPRI.EQ.1) WRITE(NTOUT,2017)(HW(K),K=1,IPRGE)
      IF(IPRI.EQ.1) WRITE(NTOUT,2018)(PAS(K),K=1,IPRGE)
 2017 FORMAT(' HW(K) ',10E12.4)
 2018 FORMAT(' PAS(K)',10E12.4)
C     LEAST SQUARES ESTIMATES OF HW AND PAS
CTAM  HWM=PAM=0.0
      HWM=0.0
      PAM=0.0
CTAM  WS=WXS=WS2=WXS2=0.0
      WS=0.0
      WXS=0.0
      WS2=0.0
      WXS2=0.0
      DO 125 K=1,IPRGE
      W=CARR(JL+K-1)
      HWW=HW(K)
      IF(HWW.EQ.0.0) GO TO 124
      WS=WS+W
      WXS=WXS+W*HWW
  124 IF(IPAS.GT.0) GO TO 125
      PAA=PAS(K)
      IF(PAA.EQ.0.0) GO TO 125
      WS2=WS2+W
      WXS2=WXS2+W*PAA
  125 CONTINUE
      IF(WS.EQ.0.0) GO TO 126
      HWM=WXS/WS
  126 IF(HWM.GE.HWMX) HWM=0.0
      IF(WS2.EQ.0.0) GO TO 130
      PAM=WXS2/WS2
      IF(PAM.LT.PAEPS) PAM=PAEPS
C     SAVE TWO-THETA, HALFWIDTH, ASYMMETRY PARAMETER
C     OF THIS PEAK IN ARRAY A
  130 IPST = IPST + 3
      A(IPST) = TS
      A(IPST+1) = HWM
      A(IPST+2) = PAM
      IF(IPRI.EQ.1) WRITE(NTOUT,2020)TS,HWM,PAM
 2020 FORMAT(' TS HWM PAM ',3E12.4)
      IPSP=IPST
      IF(ISENT.EQ.1) GO TO 159
      IF(I.EQ.IXX) GO TO 131
      IF(T.GT.TCTOFF)  GO TO 131
C     FROM TCTOFF TO TMAX THE RATIO COUNTS/SIGMA IS TO SMALL FOR
C     HW AND PAS DETERMINATION (OR COUNTS LT CTMIN)
      TARR(1)=TARR(J-1)
      CARR(1)=CARR(J-1)
      TARR(2)=TARR(J)
      CARR(2)=CARR(J)
      J=2
      I=I+1
      TX=TMAX(I)
      CX=CMAX(I)
      JD = -2
      COLD = 0.0
      TXL = TX - FLOAT(IDTARR/2)*T12
      IF(T-TXL)  133,133,70
  133 J=0
      GO TO 70
  131 IF(TTMAX-TCTOFF.LT.4.0*TSTEP)  GO TO 159
      NRD = 0
      IF(IHW.GT.0)  NRD = 1
  134 NRD = NRD + 1
C     GENERATE ADDITIONAL HW AND PAS VALUES BY EXTRAPOLATION
C     ACCORDING TO HW**2 = CU + CV*TAN(T)
C     AND PAS = C2/TAN(T)
CTAM  WS = WXS = WXQS = WYS = WXYS = 0.0
      WS=0.0
      WXS=0.0
      WXQS=0.0
      WYS=0.0
      WXYS=0.0
      PREVI = A(NRD+1)
      W = 1.0
      DO 136 IP=1,IPSP,3
      T = A(IP)
      IF(T.GT.TCTOFF)  GO TO 137
      Y = A(IP+NRD)
      IF(Y.EQ.0.0)  GO TO 136
      IF(Y.GT.1.4*PREVI)  Y = 1.3*PREVI
      PREVI = Y
      IF(NRD.EQ.1)  Y = Y*Y
      X = TAN(PI180*T/2.0)
      IF(NRD.EQ.2)  X = 1.0/X
      WXQS = WXQS + W*X*X
      WYS = WYS + W*Y
      IF(NRD.EQ.2)  GO TO 136
      WS = WS + W
      WXS = WXS + W*X
      WXYS = WXYS + W*X*Y
  136 CONTINUE
  137 IF(NRD.EQ.2)  GO TO 141
      C1 = DET(WYS,WXS,WXYS,WXQS)/DET(WS,WXS,WXS,WXQS)
      C2 = DET(WS,WYS,WXS,WXYS)/DET(WS,WXS,WXS,WXQS)
      IF(IPRI.EQ.1)  WRITE(NTOUT,2002) C1,C2
 2002 FORMAT(' C1,C2 = ',2E12.4)
      IF(C2.LT.0.01)  C2 = .01
      C1M = -C2*TAN(PI180*TCTOFF/2.0)
      IF(C1.LT.C1M)  C1 = C1M
      IF(IPRI.EQ.1)  WRITE(NTOUT,2002)C1,C2
      CU = C1
      CV = C2
      IF(IPAS.GT.0)  GO TO 138
      GO TO 134
  141 C2 = WYS/WXQS
      IF(IPRI.EQ.1)  WRITE(NTOUT,2003)C2
 2003 FORMAT(' C2 = ',E12.4)
C     SAVE GENERATED HW AND PAS VALUES ALSO IN ARRAY A
  138 T = TCTOFF
  139 T = T + 3.0*TSTEP
      IF(T.GT.TTMAX)  GO TO 159
      IPST = IPST + 3
      A(IPST)  = T
      X = TAN(PI180*T/2.0)
      IF(IHW.EQ.0)  A(IPST+1) = SQRT(CU + CV*X)
      IF(IPAS.EQ.0) A(IPST+2) = AMAX1(C2/X,PAEPS)
      IF(IPRI.EQ.1)  WRITE(NTOUT,2020) (A(IPST+II-1),II=1,3)
      GO TO 139
  156 READ(IHAIN,1025) T
      IPST = -3
  157 IPST = IPST + 3
      READ(IHAIN,1045) (A(IPST+I),I=1,3)
      IF(A(IPST+1)) 158,158,157
  158 IPST = IPST - 2
  159 IP3=IPST+2
C----WRITE WD AND PAS AS DETERMINED FROM PATTERN
      WRITE(NTOUT,2160)
 2160 FORMAT(/' VALUES OF HALF WIDTH, PEAK ASYMMETRY AS DETERMINED FROM
     $ PATTERN'//)
      WRITE(NTOUT,2163)
 2163 FORMAT(7X,'2 THETA      HALFWD/2      PEAKAS'/)
      WRITE(NTOUT,2165) (A(I),I=1,IP3)
 2165 FORMAT(2X,F12.2,F14.5,F12.5)
      NRD=0
      IF(IHW.GT.0) NRD=1
  140 NRD=NRD+1
      IF(NRD.GT.2)  GO TO 230
      NPASS = 0
C     GENERATE SMOOTHED HW, PAS AND SIGM VALUES DISTRIBUTED OVER
C     EQUIDISTANT TWO-THETA STEPS FROM TSTART TO TEND
  143 T=TSTART
      DO 145 I=1,NSTEPS
CTAM  WS=WXS=WXQS=WYS=WXYS=0.0
      WS=0.0
      WXS=0.0
      WXQS=0.0
      WYS=0.0
      WXYS=0.0
      DO 150 IP=1,IPST,3
      Y = A(IP + NRD)
      IF(Y.EQ.0.0) GO TO 150
      X=A(IP)-T
      W=1.0/(BSQ+X*X)
      WS=WS+W
      WXS=WXS+W*X
      WXQS=WXQS+W*X*X
      WYS=WYS+W*Y
      WXYS=WXYS+W*X*Y
  150 CONTINUE
      CARR(I)=DET(WYS,WXS,WXYS,WXQS)/DET(WS,WXS,WXS,WXQS)
  145 T=T+TSTEP
      NPASS = NPASS + 1
C     STORE THE SMOOTHED VALUES IN THE ARRAYS HWAR AND PASAR
      IF(NRD.EQ.2) GO TO 220
      DO 215 L=1,NSTEPS
  215 HWAR(L)=CARR(L)
      IF(NPASS.GE.3)  GO TO 140
C----REJECT BAD VALUES OF RAW WD
      IFLAG = 0
      DO 218 IP = 1,IPSP,3
      IF(A(IP+1)) 218,218,216
  216 CALL TTINTPL (A(IP),0,WD)
      IF(WD*1.4 - A(IP+1)) 217,217,218
  217 IFLAG = 1
      A(IP+1) = 0.0
  218 CONTINUE
      IF(IFLAG) 219,219,143
  219 IF(IPAS.GT.0)  GO TO 230
      GO TO 140
  220 DO 221 L=1,NSTEPS
  221 PASAR(L)=AMAX1(CARR(L),PAEPS)
      IF(NPASS.GE.3)  GO TO 230
C----REJECT BAD VALUES OF RAW PEAKAS
      IFLAG = 0
      DO 225 IP=1,IPSP,3
      IF(A(IP+2)) 224,225,223
  223 CALL TTINTPL (A(IP),100,PA)
      IF(PA*1.4-A(IP+2)) 224,224,225
  224 IFLAG = 1
      A(IP+2) = 0.
  225 CONTINUE
      IF(IFLAG) 230,230,143
C----WRITE RAW WD AND PA VALUES ON FILE IHAOUT
  230 T = 0.0
      JUNK  = 2
      WRITE(IHAOUT,1025) TSTART,TEND,T,JUNK
      WRITE(IHAOUT,1045) (A(I),I=1,IP3)
      T = -1.0
      WRITE(IHAOUT,1045) T
C----PRINT WD AND PEAKAS VALUES AFTER DISCARDING ANOMALOUS VALUES
      WRITE(NTOUT,2170)
 2170 FORMAT(/' LIST OF HALF WIDTH AND PEAK ASYMMETRY AFTER DISCARDING',
     $ ' ANOMALOUS VALUES'//)
      WRITE(NTOUT,2163)
      WRITE(NTOUT,2165) (A(I),I=1,IP3)
      IWHA = 1
      IF(IHW.LE.0.AND.IPAS.LE.0) GO TO 260
      IF(IHW.EQ.2.AND.IPAS.EQ.2) GO TO 250
      IF(IHW.NE.1.AND.IPAS.NE.1) GO TO 250
C     READ HW, PAS AND SIGM VALUES FROM FILE IHAIN
  231 READ(IHAIN,1025) TSTART,TEND,TSTEP
 1025 FORMAT (1x,3F10.2,I5)
      IF(TSTEP) 232,232,234
C----SKIP UNSMOOTHED VALUES
  232 READ(IHAIN,1045) T
      IF(T) 231,232,232
  234 NSTEPS=0
  235 READ(IHAIN,1045,END=245) T,HWW,PAA
CTAM  IF(EOF(IHAIN)) 245,240
  240 NSTEPS=NSTEPS+1
      IF(IHW.EQ.1) HWAR(NSTEPS)=HWW
      IF(IPAS.EQ.1) PASAR(NSTEPS)=PAA
      GO TO 235
  245 QINT=1.0/TSTEP
  250 IF(IHW.NE.2.AND.IPAS.NE.2) GO TO 260
C     CALCULATE HW AND PAS BY FORMULAE
      THSTEP=PI180*(TSTEP/2.0)
      T=PI180*(TSTART/2.0)
      DO 255 L=1,NSTEPS
      TANT=TAN(T)
      TANTQ=TANT*TANT
      IF(IHW.EQ.2) HWAR(L)=(SQRT(WDU+WDV*TANT+WDW*TANTQ))/2.
      IF(IPAS.EQ.2) PASAR(L)=CA1+(CA2/TANT)+(CA3/TANTQ)
  255 T=T+THSTEP
  260 CONTINUE
  275 IF(IWHA.LE.0) GO TO 285
      JUNK = 2
      WRITE(IHAOUT,1025) TSTART,TEND,TSTEP,JUNK
      T=TSTART
      DO 280 L=1,NSTEPS
      WRITE(IHAOUT,1045) T,HWAR(L),PASAR(L)
  280 T=T+TSTEP
  285 CONTINUE
 1045 FORMAT(F10.4,2E14.6)
      RETURN
      END

      SUBROUTINE INTPOL(NL,NU,Y,ABCD)
      DIMENSION Y(101),Y1(101),ABCD(4,101)
c     DIMENSION Y2(101)
      P=10.0
      PP2=P*(P+3.0)+3.0
      P22=2.0+P
      PP1=1.0+P22
      PPP=2.0*PP2*PP1
      BK=1.0/(P22*P22-1.0)
      HP=BK*PP2
CTAM  ABCD(3,NL)=ABCD(4,NL)=0.0
      ABCD(3,NL)=0.0
      ABCD(4,NL)=0.0
      NLP1=NL+1
      NU1=NU-1
      Y1(NL)=0.0
      Y1(NU)=0.0
      DO 2 K=NL,NU1
      KP1=K+1
      ABCD(1,K)=1.0
      ABCD(2,K)=BK
      R2=BK*(Y(KP1)-Y(K))
      IF(K.EQ.NL) GO TO 2
      KM1=K-1
      Z=1.0/(HP*(P22-ABCD(3,KM1))+HP*P22)
      ABCD(3,K)=Z*HP
      H=R2*PPP
      IF(K.EQ.NLP1) H=H-HP*Y1(NL)
      IF(K.EQ.NU1) H=H-HP*Y1(NU)
      IF(ABS(ABCD(4,KM1)).LE.0.1E-30) ABCD(4,KM1) = 0.0
      ABCD(4,K)=Z*(H-HP*ABCD(4,KM1))
    2 CONTINUE
      Y1(NU1)=ABCD(4,NU1)
      IF(NU1.LE.NLP1) GO TO 4
      N2=NU-NL-1
      DO 3 KK=2,N2
      K=NU-KK
      IF(ABS(Y1(K+1)).LE.0.1E-30) Y1(K+1) = 0.0
      Y1(K)=ABCD(4,K)-ABCD(3,K)*Y1(K+1)
    3 CONTINUE
    4 DO 5 K=NL,NU1
      KP1=K+1
      H=ABCD(2,K)*(Y(KP1)-Y(K))
      Z=ABCD(2,K)*ABCD(1,K)
      ABCD(3,K)=PP1*H-Z*(Y1(KP1)+P22*Y1(K))
      ABCD(4,K)=-PP1*H+Z*(P22*Y1(KP1)+Y1(K))
      ABCD(1,K)=Y(K)-ABCD(3,K)
      ABCD(2,K)=Y(KP1)-ABCD(4,K)
c     Y2(K)=-2.0*PP2*ABCD(3,K)
    5 CONTINUE
      RETURN
      END
      SUBROUTINE FINTPL(NL,NU,ABCD,X,FPL)
      DIMENSION ABCD(4,101)
      P=10.0
      NR=X
      IF(NR.LT.NL) NR=NL
      NU1=NU-1
      IF(NR.GT.NU1) NR=NU1
      T=X-FLOAT(NR)
      IF(NR.EQ.NL.AND.T.LT.0.0) T=0.0
      IF(NR.EQ.NU1.AND.T.GT.1.0) T=1.0
      U=1.0-T
      T3=T**3
      U3=U**3
      TR=1.0/(P*T+1.0)
      UR=1.0/(P*U+1.0)
      FPL=ABCD(1,NR)*U+ABCD(2,NR)*T+ABCD(3,NR)*U3*TR+ABCD(4,NR)*T3*UR
      RETURN
      END
      SUBROUTINE FINDPK(Y,MX,TX,YX,NL,NU)
      DIMENSION Y(101),ABCD(4,101)
      CALL INTPOL(NL,NU,Y,ABCD)
      TX=FLOAT(MX)
      DT=0.0001
      TL=TX-DT
      TR=TX+DT
      CALL FINTPL(NL,NU,ABCD,TL,FL)
      CALL FINTPL(NL,NU,ABCD,TX,FX)
      CALL FINTPL(NL,NU,ABCD,TR,FR)
    1 IF(FL.LE.FX.AND.FR.LE.FX) GO TO 10
      IF(FL.GT.FX) GO TO 5
      TL=TX
      FL=FX
      TX=TR
      FX=FR
      TR=TR+DT
      CALL FINTPL(NL,NU,ABCD,TR,FR)
      GO TO 1
    5 TR=TX
      FR=FX
      TX=TL
      FX=FL
      TL=TL-DT
      CALL FINTPL(NL,NU,ABCD,TL,FL)
      GO TO 1
   10 IF(FL.EQ.FX.AND.FR.EQ.FX) RETURN
      IF(FL.LT.FX) TX=0.5*(TX+TR)
      IF(FR.LT.FX) TX=0.5*(TL+TX)
      CALL FINTPL(NL,NU,ABCD,TX,YX)
      RETURN
      END
      SUBROUTINE TTINTPL(TT,INCR,FV)
      COMMON /PA/ ICURV,IHAIN,IHAOUT,IHW,IPAS,IWHA,JL,JU,IPRANA,
     $            CTMIN,HWMX,QJT,QINT,TSTART,TSTEP,
     $            ZP,HWAR(100),PASAR(100)
      DIMENSION AR(200)
      EQUIVALENCE (AR(1),HWAR(1))
      IDHAS = 100
      IPOS=1.0+QINT*(TT-TSTART)
      IF(IPOS.LT.1)  IPOS = 1
      IF(IPOS.GE.IDHAS) IPOS = IDHAS - 1
      TA=TSTART+TSTEP*FLOAT(IPOS-1)
      IPOS = IPOS + INCR
      FA=AR(IPOS)
      FB=AR(IPOS+1)
      Q=(FB-FA)*QINT
      FV=Q*(TT-TA)+FA
      RETURN
      END
      FUNCTION XLPFAC (ATHETC)
      CHARACTER*1 ITIT,ICOMP
      integer*4 junk
      COMMON IBS,IDEX,IPAGE,IPROF,ISYMF,ISYST,LAUE,LCRD,LISTH,
     $       IWD,IASYM,IXN,MH,MK,ML,NF,
     $       MAXHKL,NERO,NEX,NMAX,NREFL,NTCRD,NTIN,NTOUT,
     $       POLRA,QMAX,RANGE,RDATE,RD,RVOL,
     $       THMAX,THMIN,VOL,WDU,WDV,WDW,XLAMDA,STEP,
     $       CA1,CA2,CA3,
     $       CC(6),ITIT(74),ICOMP(6),RCC(6),RCP(6)
     $       ,POV(3),PREFOF
      common junk(7521)

      COS2TH = COS(ATHETC)
      PM = (1. + POLRA*COS2TH*COS2TH) * 2.
      THETC1 = ATHETC * .5
      SINTH = SIN(THETC1)
      P = SINTH * SINTH * COS(THETC1)
      XLPFAC = P * (1. + POLRA) / PM
      RETURN
      END
